# encoding: utf-8
#
# Alipay決済 確認要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID 与信完了取引のIDを指定
#-------------------------------------------------------
# 対象の取引IDを指定します
@order_id = "change_order_here"

#-------------------------------------------------------
# レスポンスタイプ
# "0" : 取引確定時にレスポンスを返却する。
# "1" : 即時にレスポンスを返却する。
#-------------------------------------------------------
@response_type = "0"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::AlipayConfirmRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.response_type = @response_type.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)
#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Cust Txn]: #{@response_data.cust_txn}"
  puts "[Center Trade ID]: #{@response_data.center_trade_id}"
  puts "[Pay Time JP]: #{@response_data.pay_time_jp}"
  puts "[Pay Time CN]: #{@response_data.pay_time_cn}"
  puts "[Buyer Charged Amount Cny]: #{@response_data.buyer_charged_amount_cny}"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Cust Txn]: #{@response_data.cust_txn}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
