# encoding: utf-8
#
# Amazon Pay 決済申込 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 決済金額
#-------------------------------------------------------
@amount = "100"

#-------------------------------------------------------
# 与信同時売上フラグ
#-------------------------------------------------------
@with_capture = "false"

#-------------------------------------------------------
# 配送先表示抑制フラグ
#-------------------------------------------------------
@suppress_shipping_address_view = "false"

#-------------------------------------------------------
# プラットフォームID
#-------------------------------------------------------
@platform_id = "";

#-------------------------------------------------------
# 注文説明
#-------------------------------------------------------
@note_to_buyer = "テスト商品"

#-------------------------------------------------------
# 完了時URL
#-------------------------------------------------------
#@success_url = "https://sample.com"

#-------------------------------------------------------
# キャンセル時URL
#-------------------------------------------------------
#@cancel_url = "https://sample.com"

#-------------------------------------------------------
# エラー時URL
#-------------------------------------------------------
#@error_url = "https://sample.com"

#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::AmazonpayAuthorizeRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.amount = @amount.to_s
@request_data.with_capture = @with_capture.to_s
@request_data.suppress_shipping_address_view = @suppress_shipping_address_view.to_s
@request_data.platform_id = @platform_id.to_s
@request_data.note_to_buyer = @note_to_buyer.to_s
@request_data.success_url = @success_url.to_s
@request_data.cancel_url = @cancel_url.to_s
@request_data.error_url = @error_url.to_s

#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Response Contents]: #{@response_data.response_contents}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
