# encoding: utf-8
#
# Amazon Pay 住所情報取得 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(住所情報取得対象の取引IDを設定してください)
#-------------------------------------------------------
@order_id = ""

#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::AmazonpayGetAddressRequestDto.new
@request_data.order_id = @order_id.to_s

#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Center Response Datetime]: #{@response_data.center_response_datetime}"
  puts "[Shipping Name]: #{@response_data.shipping_name}"
  puts "[Shipping Phone]: #{@response_data.shipping_phone}"
  puts "[Shipping Address1]: #{@response_data.shipping_address1}"
  puts "[Shipping Address2]: #{@response_data.shipping_address2}"
  puts "[Shipping Address3]: #{@response_data.shipping_address3}"
  puts "[Shipping Prefecture]: #{@response_data.shipping_prefecture}"
  puts "[Shipping Postal Code]: #{@response_data.shipping_postal_code}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
