# encoding: utf-8
#
# クレジットカード決済 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 同時売上実施有無
#-------------------------------------------------------
@is_with_capture = "false"

#-------------------------------------------------------
# 支払金額
#-------------------------------------------------------
@payment_amount = "5"

#-------------------------------------------------------
# 支払オプション
#-------------------------------------------------------
@jpo = "10"

#-------------------------------------------------------
# トークン
#-------------------------------------------------------
@token = "0a812412-682c-4dad-8a5d-720caf23bca0";

#-------------------------------------------------------
# カード番号
#-------------------------------------------------------
#@card_number = "4111-1111-1111-1111"

#-------------------------------------------------------
# カード有効期限 MM/YY
#-------------------------------------------------------
#@card_expire = "12/16"

#-------------------------------------------------------
# セキュリティコード
#-------------------------------------------------------
#@security_code = "1234"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CardAuthorizeRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.with_capture = @is_with_capture.to_s
@request_data.amount = @payment_amount.to_s
@request_data.jpo = @jpo.to_s
@request_data.token = @token.to_s
#@request_data.card_number = @card_number.to_s
#@request_data.card_expire = @card_expire.to_s
#@request_data.security_code = @security_code.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Center Reference Number]: #{@response_data.center_reference_number}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Center Reference Number]: #{@response_data.center_reference_number}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Center Reference Number]: #{@response_data.center_reference_number}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
