# encoding: utf-8
#
# クレジットカード決済 再与信要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 元取引ID
# 対象とする過去の取引IDを指定
#-------------------------------------------------------
# 対象の取引IDを指定します
@original_order_id = "change_order_id"

#-------------------------------------------------------
# 同時売上実施有無
#-------------------------------------------------------
@is_with_capture = "true"

#-------------------------------------------------------
# 支払金額
#-------------------------------------------------------
@amount = "5"

#-------------------------------------------------------
# 支払オプション
#-------------------------------------------------------
@jpo = "10"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CardReAuthorizeRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.original_order_id = @original_order_id.to_s
@request_data.amount = @amount.to_s
@request_data.with_capture = @is_with_capture.to_s
@request_data.jpo = @jpo.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
    puts "...Transaction Successfully Complete"
    puts "[Status]: #{@txn_status}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
    puts "[Card Number]: #{@response_data.req_card_number}"
    puts "[Center Reference Number]: #{@response_data.center_reference_number}"
end
# ペンディング
if "pending" == @txn_status
    puts "...Transaction Pending"
    puts "[Status]: #{@txn_status}"
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
    puts "[Card Number]: #{@response_data.req_card_number}"
    puts "[Center Reference Number]: #{@response_data.center_reference_number}"
    puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
    puts "...Transaction Failure"
    puts "[Status]: #{@txn_status}"
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
    puts "[Card Number]: #{@response_data.req_card_number}"
    puts "[Center Reference Number]: #{@response_data.center_reference_number}"
    puts "Check log file for more information"
end

#puts @response_data.to_string
