# encoding: utf-8
#
# キャリア決済申込 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# サービスオプションタイプ
#-------------------------------------------------------
@service_option_type = "au"

#-------------------------------------------------------
# 金額
#-------------------------------------------------------
@amount = "10"

#-------------------------------------------------------
# 端末種別
#-------------------------------------------------------
@terminal_kind = "0"

#-------------------------------------------------------
# 商品タイプ
#-------------------------------------------------------
@item_type = "0"

#-------------------------------------------------------
# 課金種別（0:都度、1:継続、4:随時）
#-------------------------------------------------------
@accounting_type = "0"

#-------------------------------------------------------
# 与信同時売上フラグ
#-------------------------------------------------------
@with_capture = "false"

#-------------------------------------------------------
# 本人認証（３Ｄセキュア）
#-------------------------------------------------------
#@d3_flag = ""

#-------------------------------------------------------
# 初回課金年月日
#-------------------------------------------------------
#@mp_first_date = ""

#-------------------------------------------------------
# 継続課金日
#-------------------------------------------------------
#@mp_day = ""

#-------------------------------------------------------
# 商品番号
#-------------------------------------------------------
@item_id = "123456"

#-------------------------------------------------------
# 商品情報
#-------------------------------------------------------
#@item_info = ""

#-------------------------------------------------------
# 決済完了時URL
#-------------------------------------------------------
#@success_url = ""

#-------------------------------------------------------
# 決済キャンセル時URL
#-------------------------------------------------------
#@cancel_url = ""

#-------------------------------------------------------
# 決済エラー時URL
#-------------------------------------------------------
#@error_url = ""

#-------------------------------------------------------
# プッシュURL
#-------------------------------------------------------
#@push_url = ""

#-------------------------------------------------------
# OpenID
#-------------------------------------------------------
@open_id = ""

#-------------------------------------------------------
# フレッツエリア
#-------------------------------------------------------
#@flets_area = ""


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CarrierAuthorizeRequestDto.new
@request_data.service_option_type = @service_option_type.to_s
@request_data.order_id= @order_id.to_s
@request_data.with_capture= @with_capture.to_s
@request_data.amount= @amount.to_s

@request_data.item_id= @item_id.to_s
@request_data.accounting_type= @accounting_type.to_s
@request_data.terminal_kind= @terminal_kind.to_s
@request_data.item_type= @item_type.to_s
#@request_data.open_id= @open_id.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg
#
# レスポンスコンテンツ取得
#
@response_contents = @response_data.response_contents


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
