# encoding: utf-8
#
# キャリア決済キャンセル 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(与信時に利用したものを設定してください)
#-------------------------------------------------------
@order_id = ""

#-------------------------------------------------------
# サービスオプションタイプ
#-------------------------------------------------------
@service_option_type = "au"

#-------------------------------------------------------
# 課金取消月
#-------------------------------------------------------
@cancel_month = ""

#-------------------------------------------------------
# 金額
#-------------------------------------------------------
@amount = ""

#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CarrierCancelRequestDto.new
@request_data.service_option_type = @service_option_type.to_s
@request_data.order_id= @order_id.to_s
@request_data.cancel_month= @cancel_month.to_s
@request_data.amount= @amount.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 残高取得
#
@balance = @response_data.balance
#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg
#
# 取消日時取得
#
@cancel_datetime = @response_data.cancel_datetime


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Balance]: #{@balance}"
  puts "[Cancel Datetime]: #{@cancel_datetime}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
