# encoding: utf-8
#
# キャリア決済 限度額確保要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# サービスオプションタイプ
#-------------------------------------------------------
@service_option_type = "docomo"

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 元取引ID
# 対象とする過去の取引IDを指定
#-------------------------------------------------------
@original_order_id = ""

#-------------------------------------------------------
# 与信方法(同時売上実施の有無)
#-------------------------------------------------------
@is_with_capture = "false"

#-------------------------------------------------------
# 金額
#-------------------------------------------------------
@amount = "10"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CarrierReAuthorizeRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.original_order_id = @original_order_id.to_s
@request_data.with_capture = @is_with_capture.to_s
@request_data.amount = @amount.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
    puts "...Transaction Successfully Complete"
    puts "[Status]: #{@txn_status}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
end
# ペンディング
if "pending" == @txn_status
    puts "...Transaction Pending"
    puts "[Status]: #{@txn_status}"
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
    puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
    puts "...Transaction Failure"
    puts "[Status]: #{@txn_status}"
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
    puts "Check log file for more information"
end

#puts @response_data.to_string
