# encoding: utf-8
#
# 電子マネー決済 キャンセル要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 決済方式
#
# モバイルSuicaメール決済 : suica-mobile-mail
# モバイルSuicaアプリ決済 : suica-mobile-app
# Suicaインターネット決済メール連携 : suica-pc-mail
# Suicaインターネット決済アプリ連携 : suica-pc-app
# nanaco決済 : tcc-redirect
#-------------------------------------------------------
@service_option_type = "suica-mobile-mail"

#-------------------------------------------------------
# 取引ID（決済申込時の取引IDを指定）
#-------------------------------------------------------
@order_id = "change_order_id"

#-------------------------------------------------------
# オーダー種別
#-------------------------------------------------------
@order_kind = "authorize"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::EmCancelRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.service_option_type = @service_option_type.to_s

if @service_option_type.to_s.start_with?("suica")
  # Suica決済の場合
  @request_data.order_kind = @order_kind.to_s
end


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
