# encoding: utf-8
#
# クレジットカード決済(本人認証) 本人認証結果確認要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID(対象取引IDを設定してください)
#-------------------------------------------------------
@order_id = ""


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::MpiGetResultRequestDto.new
@request_data.order_id= @order_id.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
    puts "...Transaction Successfully Complete"
    puts "[Status]: #{@txn_status}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[Order ID]: #{@response_data.order_id}"
    puts "[Request Id]: #{@response_data.request_id}"
    puts "[Req Amount]: #{@response_data.req_amount}"
    puts "[Req Card Number]: #{@response_data.req_card_number}"
    puts "[Mpi Mstatus]: #{@response_data.mpi_mstatus}"
    puts "[Mpi Vresult Code]: #{@response_data.mpi_vresult_code}"
    puts "[Card Mstatus]: #{@response_data.card_mstatus}"
    puts "[Auth Code]: #{@response_data.auth_code}"
    puts "[Ddd Message Version]: #{@response_data.ddd_message_version}"
    puts "[Ddd Transaction Id]: #{@response_data.ddd_transaction_id}"
    puts "[Ddd Ds Transaction Id]: #{@response_data.ddd_ds_transaction_id}"
    puts "[Ddd Server Transaction Id]: #{@response_data.ddd_server_transaction_id}"
    puts "[Ddd Transaction Status]: #{@response_data.ddd_transaction_status}"
    puts "[Ddd Cavv Algorithm]: #{@response_data.ddd_cavv_algorithm}"
    puts "[Ddd Cavv]: #{@response_data.ddd_cavv}"
    puts "[Ddd Eci]: #{@response_data.ddd_eci}"
end
# 失敗
if "failure" == @txn_status
    puts "...Transaction Failure"
    puts "[Status]: #{@txn_status}"
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "Check log file for more information"
end

#puts @response_data.to_string
