# encoding: utf-8
#
# PayNowId カード情報取得要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 会員ID
#-------------------------------------------------------
@account_id = "TestAccountId"


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::CardInfoGetRequestDto.new
@request_data.account_id = @account_id.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

unless @response_data.pay_now_id_response.nil?
  pay_now_id_response = @response_data.pay_now_id_response
  #
  # PayNowIDステータス取得
  #
  @pay_now_id_status = pay_now_id_response.status
  #
  # PayNowID処理番号取得
  #
  @pay_now_id_proc_id = pay_now_id_response.process_id

  unless pay_now_id_response.account.nil?
    #
    # カード情報取得
    #
    @card_info_array = pay_now_id_response.account.card_info
  else
    @card_info_array = []
  end
end


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @pay_now_id_status
  puts "...Transaction Successfully Complete"
  puts "[PayNowId Status]: #{@pay_now_id_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[PayNowId ProcessId]: #{@pay_now_id_proc_id}"

  puts "[CardInfo Count]: #{@card_info_array.length}"
  @card_info_array.each_with_index do |info, index|
    puts "  [#{index+1}] #{info.card_id} : #{info.card_number} : #{info.card_expire}"
  end
end
# 失敗
if "failure" == @pay_now_id_status
  puts "...Transaction Failure"
  puts "[PayNowId Status]: #{@pay_now_id_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[PayNowId ProcessId]: #{@pay_now_id_proc_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
