# encoding: utf-8
#
# PayNowId 継続課金変更要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 会員ID
#-------------------------------------------------------
@account_id = "TestAccountId"

#-------------------------------------------------------
# 課金グループID
#-------------------------------------------------------
@group_id = "TestGroupId"

#-------------------------------------------------------
# 課金終了日
#-------------------------------------------------------
@end_date = (Time.now + 24*60*60*3000).strftime("%Y%m%d").to_s

#-------------------------------------------------------
# 都度／初回課金金額
#-------------------------------------------------------
@one_time_amount = "25"

#-------------------------------------------------------
# 継続課金金額
#-------------------------------------------------------
@recurring_amount = "10"

#-------------------------------------------------------
# カード番号
#-------------------------------------------------------
# @card_number = "4111-1111-1111-1111"

#-------------------------------------------------------
# カード有効期限 MM/YY
#-------------------------------------------------------
# @card_expire = "12/16"

#-------------------------------------------------------
# トークン
#-------------------------------------------------------
@token = "0a812412-682c-4dad-8a5d-720caf23bca0";


#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::RecurringUpdateRequestDto.new
@request_data.account_id = @account_id.to_s
@request_data.group_id = @group_id.to_s
@request_data.end_date = @end_date.to_s
@request_data.one_time_amount = @one_time_amount.to_s
@request_data.amount = @recurring_amount.to_s
# @request_data.card_number = @card_number.to_s
# @request_data.card_expire = @card_expire.to_s
@request_data.token = @token.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg

unless @response_data.pay_now_id_response.nil?
    pay_now_id_response = @response_data.pay_now_id_response
    #
    # PayNowIDステータス取得
    #
    @pay_now_id_status = pay_now_id_response.status
    #
    # PayNowID処理番号取得
    #
    @pay_now_id_proc_id = pay_now_id_response.process_id

    unless pay_now_id_response.account.nil?
        account = pay_now_id_response.account

        unless account.card_info.nil? || !account.card_info.is_a?(Array) || account.card_info.empty?
            # 先頭の情報を取得する
            card_info = account.card_info[0]
            #
            # カードID取得
            #
            @card_id = card_info.card_id
        end
    end
end


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @pay_now_id_status
    puts "...Transaction Successfully Complete"
    puts "[PayNowId Status]: #{@pay_now_id_status}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[PayNowId ProcessId]: #{@pay_now_id_proc_id}"
    puts "[CardId]: #{@card_id}"
end
# 失敗
if "failure" == @pay_now_id_status
    puts "...Transaction Failure"
    puts "[PayNowId Status]: #{@pay_now_id_status}"
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[PayNowId ProcessId]: #{@pay_now_id_proc_id}"
    puts "Check log file for more information"
end
# pay_now_id_status が null の場合
if @pay_now_id_status.nil?
    puts "[PayNowId Status]: I do not know the status because of pay_now_id_response is null."
    puts "[Message]: #{@error_message}"
    puts "[Result Code]: #{@txn_result_code}"
    puts "[PayNowId ProcessId]: I do not know the processId because of pay_now_id_response is null."
    puts "Check log file for more information"
end

#puts @response_data.to_string
