# encoding: utf-8
#
# PayPay 決済申込 要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
@order_id = "dummy" + Time.now.to_i.to_s

#-------------------------------------------------------
# 決済金額
#-------------------------------------------------------
@amount = "100"

#-------------------------------------------------------
# 商品ID
#-------------------------------------------------------
@item_id = "123456"

#-------------------------------------------------------
# 決済完了時URL
#-------------------------------------------------------
@success_url = "http://localhost/web/paypay/Result?result=SUCCESS"

#-------------------------------------------------------
# 決済キャンセル時URL
#-------------------------------------------------------
@cancel_url = "http://localhost/web/paypay/Result?result=CANCEL"

#-------------------------------------------------------
# 決済エラー時URL
#-------------------------------------------------------
@error_url = "http://localhost/web/paypay/Result?result=ERROR"

#==========================================================================
# 要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::PaypayAuthorizeRequestDto.new
@request_data.order_id= @order_id.to_s
@request_data.amount= @amount.to_s
@request_data.item_id= @item_id.to_s
@request_data.success_url= @success_url.to_s
@request_data.cancel_url= @cancel_url.to_s
@request_data.error_url= @error_url.to_s
@request_data.service_option_type = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_ONLINE;

#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg
#
# レスポンスコンテンツ取得
#
@response_contents = @response_data.response_contents

#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Response Contents]: #{@response_contents}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string