# encoding: utf-8
#
# サーチサンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

def is_true(flag)
  return defined?(flag) && flag == 'true'
end

#=================================================
# 要求電文パラメータ
#=================================================
#=================================================
# 1. 対象リクエストID
#=================================================
@request_id = ""

#=================================================
# 2. サービスタイプ
# 配列指定
#
# クレジットカード：card
# 電子マネー：em
# コンビニ：cvs
# 銀行：bank
# PayPal:paypal
# セゾン：saison
# 銀聯ネット決済(UPOP)：upop
# Alipay：alipay
# キャリア：carrier
# ショッピングクレジット:oricosc
# 楽天:rakuten
# リクルート:recruit
# LINE Pay:linepay
# Masterpass:masterpass
# 銀行振込:virtualacc
# PayPay:paypay
# Amazon Pay:amazonpay
# 本人認証:mpi
#=================================================
@service_code1 = 'card'
@service_code2 = 'em'
@service_code3 = 'cvs'
@service_code4 = 'bank'
@service_code5 = 'paypal'
@service_code7 = 'mpi'
@service_code8 = 'saison'
@service_code9 = 'upop'
@service_code10 = 'alipay'
@service_code11 = 'carrier'
@service_code12 = 'oricosc'
@service_code13 = 'rakuten'
@service_code14 = 'recruit'
@service_code15 = 'linepay'
@service_code16 = 'masterpass'
@service_code17 = 'virtualacc'
@service_code18 = 'paypay'
@service_code19 = 'amazonpay'
@service_code20 = 'mpi'

#@service_type = [@service_code1,@service_code2,@service_code3,@service_code4,@service_code5,@service_code7,@service_code8,@service_code9,@service_code10,@service_code11,@service_code12,@service_code13,@service_code14,@service_code15,@service_code16,@service_code17,@service_code18,@service_code19,@service_code20]
@service_type = @service_code1

#=================================================
# 3. 検索最大件数
#=================================================
@max_count = "10"

#=================================================
# 要求電文に条件セット
#=================================================
@request_data = Veritrans::Tercerog::Mdk::SearchRequestDto.new
@request_data.request_id= @request_id.to_s
@request_data.service_type_cd = @service_type.to_s
@request_data.max_count = @max_count.to_s
#@request_data.newer_flag = "true"
@request_data.contain_dummy_flag = "1"

#=================================================
# サービス間検索条件パラメータ値
#=================================================

#=================================================
# 1. 取引ID
#=================================================
@order_id = ""

#=================================================
# 2. 対象コマンド
# 配列指定
#
# Authorize/ReAuthorize/Capture/Cancel/Refund/Retry/Verify/Terminate/Remove
#=================================================
@command1 = "Authorize"
@command2 = "Capture"
@command3 = "Cancel"
@command4 = "Refund"
@target_command = [@command1,@command2,@command3,@command4]

#=================================================
# 3. 対象取引ステータス
# 配列指定
#
# success/failure/pending
#=================================================
@status1 = "success"
@status2 = "pending"
@status3 = "failure"
@transaction_status = [@status1,@status2]

#=================================================
# 4-a. 取引日時
# yyyyMMDDhhmm
#=================================================
@txn_from_datetime = "202001100000"
@txn_to_datetime = "202001312359"

#=================================================
# 5-a. 取引金額
#=================================================
@amount_lower_limit = "1"
@amount_upper_limit = "10000"

#=================================================
# 4-b. 検索範囲設定：取引期間
#=================================================
@txn_time_range =  Veritrans::Tercerog::Mdk::SearchRange.new
@txn_time_range.from = @txn_from_datetime.to_s
@txn_time_range.to = @txn_to_datetime.to_s

#=================================================
# 5-b. 検索範囲設定：取引金額
#=================================================
@amount_range = Veritrans::Tercerog::Mdk::SearchRange.new
@amount_range.from = @amount_lower_limit.to_s
@amount_range.to = @amount_upper_limit.to_s

#=================================================
# サービス間共通検索パラメータ設定(1-5)
#=================================================
@common_parameters = Veritrans::Tercerog::Mdk::CommonSearchParameter.new

@common_parameters.order_id = @order_id.to_s
@common_parameters.command = @target_command
@common_parameters.mstatus = @transaction_status
@common_parameters.txn_datetime = @txn_time_range
@common_parameters.amount = @amount_range


#=================================================
# 以下、サービス別指定
#=================================================

#=================================================
# 電子マネー固有検索パラメータ
# EmSearchParameter
#=================================================

#=================================================
# 電子マネー種別
#   Edy    : edy
#   Suica  : suica
#   WAON   : waon
#   nanaco : tcc
#=================================================
@em_code1 = "edy"
@em_code2 = "suica"
@em_type = [@em_code1,@em_code2]

#=================================================
# 検索範囲設定：決済期限日時
#=================================================
#検索始点 YYYYMMDDhhmm
@settlement_from_datetime = "201005010000"
#検索終点 YYYYMMDDhhmm
@settlement_to_datetime = "202012312359"

@settlement_limit_range = Veritrans::Tercerog::Mdk::SearchRange.new
@settlement_limit_range.from = @settlement_from_datetime.to_s
@settlement_limit_range.to = @settlement_to_datetime.to_s

#=================================================
# 検索範囲設定：決済完了日時
#=================================================
#検索始点 YYYYMMDDhhmm
@complete_from_datetime = "201005010000"
#検索終点 YYYYMMDDhhmm
@complete_to_datetime = "202012312359"

@complete_datetime_range = Veritrans::Tercerog::Mdk::SearchRange.new
@complete_datetime_range.from = @complete_from_datetime.to_s
@complete_datetime_range.to = @complete_to_datetime.to_s

@em_parameters = Veritrans::Tercerog::Mdk::EmSearchParameter.new
@em_parameters.em_type = @em_type
@em_parameters.settlement_limit = @settlement_limit_range
@em_parameters.complete_datetime = @complete_datetime_range

#=================================================
# コンビニ固有検索パラメータ
# CvsSearchParameter
#=================================================

#=================================================
# コンビニ種別
#   セブンイレブン                         : sej
#   ローソン、ファミリーマートetc          : econ
#   サークルKサンクス、デイリーヤマザキetc : other
#=================================================
@convini_code1 = "sej"
@convini_code4 = "other"
@comvini_code5 = "econ"

@cvs_type = [@convini_code1,@convini_code4,@comvini_code5]

#=================================================
# 検索範囲設定：支払期限日時
#=================================================
#検索始点 YYYYMMDDhhmm
@pay_from_datetime = "201005010000"
#検索終点 YYYYMMDDhhmm
@pay_to_datetime = "202012312359"

@pay_limit_range = Veritrans::Tercerog::Mdk::SearchRange.new
@pay_limit_range.from = @pay_from_datetime.to_s
@pay_limit_range.to = @pay_to_datetime.to_s

#=================================================
# 検索範囲設定：入金受付日
#=================================================
#検索始点 YYYYMMDDhhmm
@paid_from_datetime = "201005010000"

#検索終点 YYYYMMDDhhmm
@paid_to_datetime = "202012312359"

@paid_datetime_range = Veritrans::Tercerog::Mdk::SearchRange.new
@paid_datetime_range.from = @paid_from_datetime.to_s
@paid_datetime_range.to = @paid_to_datetime.to_s

@cvs_parameters = Veritrans::Tercerog::Mdk::CvsSearchParameter.new
@cvs_parameters.cvs_type = @cvs_type
@cvs_parameters.pay_limit = @pay_limit_range
@cvs_parameters.paid_datetime = @paid_datetime_range

#=================================================
# PayEasy固有検索パラメータ
# BankSearchParameter
#=================================================

#=================================================
# 方式種別
# ATM決済　：　atm
# ネットバンク決済PC : netbank-pc
# ネットバンク決済DoCoMo ：　netbank-docomo
# ネットバンク決済SoftBank　：　netbank-sonftbank
# ネットバンク決済au ： netbank-au
#=================================================
@bank_option1 = "atm"
@bank_option2 = "netbank-pc"
@bank_option3 = "netbank-docomo"
@bank_option4 = "netbank-softbank"
@bank_option5 = "netbank-au"
@bank_option_type = [@bank_option1,@bank_option2,@bank_option3,@bank_option4,@bank_option5]

#=================================================
# 検索範囲設定：支払期限日時
#=================================================
#検索始点 YYYYMMDDhhmm
@pay_from_datetime = "201005010000"

#検索終点 YYYYMMDDhhmm
@pay_to_datetime = "202012312359"

@pay_limit_range = Veritrans::Tercerog::Mdk::SearchRange.new
@pay_limit_range.from = @pay_from_datetime.to_s
@pay_limit_range.to = @pay_to_datetime.to_s

#=================================================
# 検索範囲設定：収納日時
#=================================================
#検索始点 YYYYMMDDhhmm
@received_from_datetime = "201005010000"

#検索終点 YYYYMMDDhhmm
@received_to_datetime = "202012312359"

@received_datetime_range = Veritrans::Tercerog::Mdk::SearchRange.new
@received_datetime_range.from = @received_from_datetime.to_s
@received_datetime_range.to = @received_to_datetime.to_s

@bank_parameters = Veritrans::Tercerog::Mdk::BankSearchParameter.new
@bank_parameters.option_type = @bank_option_type
@bank_parameters.pay_limit = @pay_limit_range
@bank_parameters.received_datetime = @received_datetime_range

#=================================================
# PayPal固有検索パラメータ
#  PaypalSearchParameter
#=================================================

#=================================================
# 検索範囲設定：支払日時
#=================================================
#検索始点 YYYYMMDDhhmm
@payment_from_datetime = "201005010000"

#検索終点 YYYYMMDDhhmm
@payment_to_datetime = "202012312359"

@payment_range = Veritrans::Tercerog::Mdk::SearchRange.new
@payment_range.from = @payment_from_datetime.to_s
@payment_range.to = @payment_to_datetime.to_s

#=================================================
# 顧客番号
#=================================================
@payer_id = "dummy"

@paypal_parameters = Veritrans::Tercerog::Mdk::PaypalSearchParameter.new
@paypal_parameters.payment_datetime = @payment_range
@paypal_parameters.payer_id = @payer_id.to_s

#=================================================
# Saison固有検索パラメータ
#  SaisonSearchParameter
#=================================================

#=================================================
# 検索範囲設定：合計決済金額
#=================================================
#検索始点
@saison_from_total_amount = "1"

#検索終点
@saison_to_total_amount = "10000"

@saison_total_amount_range = Veritrans::Tercerog::Mdk::SearchRange.new
@saison_total_amount_range.from = @saison_from_total_amount.to_s
@saison_total_amount_range.to = @saison_to_total_amount.to_s

#=================================================
# 検索範囲設定：ウォレット決済金額
#=================================================
#検索始点
@saison_from_wallet_amount = "1"

#検索終点
@saison_to_wallet_amount = "10000"

@saison_wallet_amount_range = Veritrans::Tercerog::Mdk::SearchRange.new
@saison_wallet_amount_range.from = @saison_from_wallet_amount.to_s
@saison_wallet_amount_range.to = @saison_to_wallet_amount.to_s

#=================================================
# 検索範囲設定：カード決済金額
#=================================================
#検索始点
@saison_from_card_amount = "1"

#検索終点
@saison_to_card_amount = "10000"

@saison_card_amount_range = Veritrans::Tercerog::Mdk::SearchRange.new
@saison_card_amount_range.from = @saison_from_card_amount.to_s
@saison_card_amount_range.to = @saison_to_card_amount.to_s

@saison_parameters = Veritrans::Tercerog::Mdk::SaisonSearchParameter.new
@saison_parameters.total_amount = @saison_total_amount_range
@saison_parameters.wallet_amount = @saison_wallet_amount_range
@saison_parameters.card_amount = @saison_card_amount_range

#=================================================
# 銀聯ネット決済(UPOP)固有検索パラメータ
#  UPOPSearchParameter
#=================================================
#=================================================
# 検索範囲設定：決済日時（日本）
#=================================================
#検索始点 YYYYMMDDhhmm
@settle_datetime_from_jp = "201005010000"
#検索終点 YYYYMMDDhhmm
@settle_datetime_to_jp = "202012312359"

#=================================================
# 検索範囲設定：決済日時（中国）
#=================================================
#検索始点 YYYYMMDDhhmm
@settle_datetime_from_cn = "201005010000"
#検索終点 YYYYMMDDhhmm
@settle_datetime_to_cn = "202012312359"

@detail_order_type = ["a0","a"]

@settle_datetime_jp_range = Veritrans::Tercerog::Mdk::SearchRange.new
@settle_datetime_jp_range.from = @settle_datetime_from_jp.to_s
@settle_datetime_jp_range.to = @settle_datetime_to_jp.to_s

@settle_datetime_cn_range = Veritrans::Tercerog::Mdk::SearchRange.new
@settle_datetime_cn_range.from = @settle_datetime_from_cn.to_s
@settle_datetime_cn_range.to = @settle_datetime_to_cn.to_s

@upop_parameters = Veritrans::Tercerog::Mdk::UpopSearchParameter.new
@upop_parameters.settle_datetime_jp = @settle_datetime_jp_range
@upop_parameters.settle_datetime_cn = @settle_datetime_cn_range
@upop_parameters.detail_order_type = @detail_order_type

#=================================================
# Alipay固有検索パラメータ
#  AlipaySearchParameter
#=================================================
@detail_order_type = ["payment_request","payment","refund_request","refund"]
@center_trade_id = ""

#=================================================
# 検索範囲設定：支払日時
#=================================================
#検索始点 YYYYMMDDhhmm
@payment_time_from = "201005010000"
#検索終点 YYYYMMDDhhmm
@payment_time_to = "202012312359"

#=================================================
# 検索範囲設定：清算日時
#=================================================
#検索始点 YYYYMMDDhhmm
#@settlement_time_from = "201005010000"
#検索終点 YYYYMMDDhhmm
#@settlement_time_to = "202012312359"

@payment_time_range = Veritrans::Tercerog::Mdk::SearchRange.new
@payment_time_range.from = @payment_time_from.to_s
@payment_time_range.to = @payment_time_to.to_s

#@settlement_time_range = Veritrans::Tercerog::Mdk::SearchRange.new
#@settlement_time_range.from = @settlement_time_from.to_s
#@settlement_time_range.to = @settlement_time_to .to_s

@pay_type = ["0","1","2"]

@alipay_parameters = Veritrans::Tercerog::Mdk::AlipaySearchParameter.new
@alipay_parameters.detail_order_type = @detail_order_type
@alipay_parameters.center_trade_id  = @center_trade_id
@alipay_parameters.payment_time = @payment_time_range
@alipay_parameters.settlement_time = @settlement_time_range
@alipay_parameters.pay_type = @pay_type

#=================================================
# キャリア固有検索パラメータ
#  CarrierSearchParameter
#=================================================

#=================================================
# 詳細オーダー決済状態
# 配列指定
#
# Init/Auth/Capture/…
#=================================================
@carrier_detail_order_type1 = "Init"
@carrier_detail_order_type2 = "Auth"
@carrier_detail_order_type3 = "Capture"
@carrier_detail_order_type = [@carrier_detail_order_type1,@carrier_detail_order_type2]

#=================================================
# キャリアサービスタイプ
# 配列指定
#
# au/docomo/sb_ktai/sb_matomete/s_bikkuri
#=================================================
@carrier_cr_service_type1 = "au"
@carrier_cr_service_type2 = "docomo"
@carrier_cr_service_type3 = "sb_ktai"
@carrier_cr_service_type4 = "sb_matomete"
@carrier_cr_service_type5 = "s_bikkuri"
@carrier_cr_service_type = [@carrier_cr_service_type1,@carrier_cr_service_type2]

#=================================================
# 課金タイプ 0 or 1
#=================================================
@carrier_accounting_type = "1"

#=================================================
# 商品タイプ
# 配列指定
#
# 0/1/2
#=================================================
@carrier_item_type1 = "0"
@carrier_item_type2 = "1"
@carrier_item_type3 = "2"
@carrier_item_type = [@carrier_item_type1,@carrier_item_type2,@carrier_item_type3]

#=================================================
# 継続状態フラグ
# 配列指定
#
# 1/8/9
#=================================================
@carrier_mp_status1 = "1"
@carrier_mp_status2 = "8"
@carrier_mp_status3 = "9"
@carrier_mp_status = [@carrier_mp_status1,@carrier_mp_status2,@carrier_mp_status3]

#=================================================
# 端末種別
# 配列指定
#
# 0/1/2
#=================================================
@carrier_terminal_kind1 = "0"
@carrier_terminal_kind2 = "1"
@carrier_terminal_kind3 = "2"
@carrier_terminal_kind = [@carrier_terminal_kind1,@carrier_terminal_kind2,@carrier_terminal_kind3]

#=================================================
# 詳細コマンドタイプ名
# 配列指定
#
# Init/PreOpenId/PostOpenId/PreAuth/Auth/…
#=================================================
@carrier_detail_command_type1 = "Init"
@carrier_detail_command_type2 = "PreAuth"
@carrier_detail_command_type3 = "Auth"
@carrier_detail_command_type = [@carrier_detail_command_type1,@carrier_detail_command_type2,@carrier_detail_command_type3]

#=================================================
# 初回課金年月日 yyyyMMDD
#=================================================
@carrier_mp_first_date = "20130510"

#=================================================
# 継続課金日 1～28 or 99
#=================================================
@carrier_mp_day = "99"

#=================================================
# 商品番号
#=================================================
@carrier_item_id = "1*"


@carrier_parameters = Veritrans::Tercerog::Mdk::CarrierSearchParameter.new
#@carrier_parameters.detail_order_type = @carrier_detail_order_type
@carrier_parameters.cr_service_type = @carrier_cr_service_type
#@carrier_parameters.item_type = @carrier_item_type
#@carrier_parameters.accounting_type = @carrier_accounting_type
#@carrier_parameters.mp_status = @carrier_mp_status
#@carrier_parameters.terminal_kind = @carrier_terminal_kind
#@carrier_parameters.detail_command_type = @carrier_detail_command_type
#@carrier_parameters.mp_first_date = @carrier_mp_first_date
#@carrier_parameters.mp_day = @carrier_mp_day
#@carrier_parameters.item_id = @carrier_item_id

#=================================================
# ショッピングクレジット固有検索パラメータ
#  OricoscSearchParameter
#=================================================

#=================================================
# 注文番号
#=================================================
@oricosc_orico_order_no = "dummy1374148140"

#=================================================
# 検索範囲設定：支払金額合計
#=================================================
#検索始点
@oricosc_from_amount = "1"

#検索終点
@oricosc_to_amount = "10000"

@oricosc_amount_range = Veritrans::Tercerog::Mdk::SearchRange.new
@oricosc_amount_range.from = @oricosc_from_amount.to_s
@oricosc_amount_range.to = @oricosc_to_amount.to_s

#=================================================
# 検索範囲設定：商品価格合計(税込)
#=================================================
#検索始点
@oricosc_from_total_item_amount = "1"

#検索終点
@oricosc_to_total_item_amount = "10000"

@oricosc_total_item_amount_range = Veritrans::Tercerog::Mdk::SearchRange.new
@oricosc_total_item_amount_range.from = @oricosc_from_total_item_amount.to_s
@oricosc_total_item_amount_range.to = @oricosc_to_total_item_amount.to_s

@oricosc_parameters = Veritrans::Tercerog::Mdk::OricoscSearchParameter.new
@oricosc_parameters.orico_order_no = @oricosc_orico_order_no
@oricosc_parameters.amount = @oricosc_amount_range
@oricosc_parameters.total_item_amount = @oricosc_total_item_amount_range

#=================================================
# 楽天ID決済固有検索パラメータ
#  RakutenSearchParameter
#=================================================

#=================================================
# 詳細オーダー決済状態
#=================================================
@rakuten_detail_order_type1 = "Init"
@rakuten_detail_order_type2 = "Auth"
@rakuten_detail_order_type = [@rakuten_detail_order_type1,@rakuten_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@rakuten_detail_command_type1 = "Init"
@rakuten_detail_command_type2 = "PreAuth"
@rakuten_detail_command_type = [@rakuten_detail_command_type1,@rakuten_detail_command_type2]

#=================================================
# 商品ID
#=================================================
@rakuten_item_id = "123456"

#=================================================
# 決済種別
#=================================================
@rakuten_pay_type1 = Veritrans::Tercerog::Mdk::MdkConst::RAKUTEN_ONLINE
@rakuten_pay_type2 = Veritrans::Tercerog::Mdk::MdkConst::RAKUTEN_ONLINE_V2
@rakuten_pay_type = [@rakuten_pay_type1,@rakuten_pay_type2]

#=================================================
# 課金種別
#=================================================
@rakuten_accounting_type = "0"

#=================================================
# 承諾状態
#=================================================
@rakuten_consent_status1 = "Init"
@rakuten_consent_status2 = "Consent"
@rakuten_consent_status = [@rakuten_consent_status1,@rakuten_consent_status2]

#=================================================
# 元取引ID
#=================================================
@rakuten_original_order_id = "12345678"

@rakuten_parameters = Veritrans::Tercerog::Mdk::RakutenSearchParameter.new
@rakuten_parameters.detail_order_type = @rakuten_detail_order_type
@rakuten_parameters.detail_command_type = @rakuten_detail_command_type
@rakuten_parameters.item_id = @rakuten_item_id.to_s
@rakuten_parameters.pay_type = @rakuten_pay_type
@rakuten_parameters.accounting_type = @rakuten_accounting_type
@rakuten_parameters.consent_status = @rakuten_consent_status
@rakuten_parameters.original_order_id = @rakuten_original_order_id

#=================================================
# リクルートかんたん支払い固有検索パラメータ
#  RecruitSearchParameter
#=================================================

#=================================================
# 商品ID
#=================================================
@recruit_item_id = "123456"

#=================================================
# 詳細オーダー決済状態
#=================================================
@recruit_detail_order_type1 = "Init"
@recruit_detail_order_type2 = "Auth"
@recruit_detail_order_type = [@recruit_detail_order_type1,@recruit_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@recruit_detail_command_type1 = "Init"
@recruit_detail_command_type2 = "PreAuth"
@recruit_detail_command_type = [@recruit_detail_command_type1,@recruit_detail_command_type2]

@recruit_parameters = Veritrans::Tercerog::Mdk::RecruitSearchParameter.new
@recruit_parameters.item_id = @recruit_item_id.to_s
@recruit_parameters.detail_order_type = @recruit_detail_order_type
@recruit_parameters.detail_command_type = @recruit_detail_command_type

#=================================================
# LINE Pay固有検索パラメータ
#  LinepaySearchParameter
#=================================================

#=================================================
# 商品ID
#=================================================
@linepay_item_id = "123456"

#=================================================
# 詳細オーダー決済状態
#=================================================
@linepay_detail_order_type1 = "Init"
@linepay_detail_order_type2 = "Auth"
@linepay_detail_order_type = [@linepay_detail_order_type1,@linepay_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@linepay_detail_command_type1 = "Init"
@linepay_detail_command_type2 = "PreAuth"
@linepay_detail_command_type = [@linepay_detail_command_type1,@linepay_detail_command_type2]

@linepay_parameters = Veritrans::Tercerog::Mdk::LinepaySearchParameter.new
@linepay_parameters.item_id = @linepay_item_id.to_s
@linepay_parameters.detail_order_type = @linepay_detail_order_type
@linepay_parameters.detail_command_type = @linepay_detail_command_type

#=================================================
# MasterPass固有検索パラメータ
#  MasterpassSearchParameter
#=================================================

#=================================================
# 商品ID
#=================================================
@masterpass_item_id = "123456"

#=================================================
# 詳細オーダー決済状態
#=================================================
@masterpass_detail_order_type1 = "Init"
@masterpass_detail_order_type2 = "Auth"
@masterpass_detail_order_type = [@masterpass_detail_order_type1,@masterpass_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@masterpass_detail_command_type1 = "Init"
@masterpass_detail_command_type2 = "Auth"
@masterpass_detail_command_type = [@masterpass_detail_command_type1,@masterpass_detail_command_type2]

@masterpass_parameters = Veritrans::Tercerog::Mdk::MasterpassSearchParameter.new
@masterpass_parameters.item_id = @masterpass_item_id.to_s
@masterpass_parameters.detail_order_type = @masterpass_detail_order_type
@masterpass_parameters.detail_command_type = @masterpass_detail_command_type

#=================================================
# 銀行振込決済固有検索パラメータ
#=================================================

#=================================================
# 詳細オーダー決済状態
#=================================================
@virtualacc_detail_order_type1 = Veritrans::Tercerog::Mdk::MdkConst::VIRTUALACC_DETAIL_ORDER_TYPE_INIT
@virtualacc_detail_order_type2 = Veritrans::Tercerog::Mdk::MdkConst::VIRTUALACC_DETAIL_ORDER_TYPE_AUTH
@virtualacc_detail_order_type = [@virtualacc_detail_order_type1,@virtualacc_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@virtualacc_detail_command_type1 = Veritrans::Tercerog::Mdk::MdkConst::VIRTUALACC_DETAIL_COMMAND_INIT
@virtualacc_detail_command_type2 = Veritrans::Tercerog::Mdk::MdkConst::VIRTUALACC_DETAIL_COMMAND_AUTH
@virtualacc_detail_command_type = [@virtualacc_detail_command_type1,@virtualacc_detail_command_type2]

#=================================================
# 登録時振込人名
#=================================================
@virtualacc_entry_transfer_name = ""

#=================================================
# 登録時振込番号
#=================================================
@virtualacc_entry_transfer_number = ""

#=================================================
# 口座番号
#=================================================
@virtualacc_account_number = ""

@virtualacc_parameters = Veritrans::Tercerog::Mdk::VirtualaccSearchParameter.new
@virtualacc_parameters.detail_order_type = @virtualacc_detail_order_type
@virtualacc_parameters.detail_command_type = @virtualacc_detail_command_type
@virtualacc_parameters.entry_transfer_name = @virtualacc_entry_transfer_name
@virtualacc_parameters.entry_transfer_number = @virtualacc_entry_transfer_number
@virtualacc_parameters.account_number = @virtualacc_account_number

#=================================================
# PayPay固有検索パラメータ
#=================================================

#=================================================
# 詳細オーダー決済状態
#=================================================
@paypay_detail_order_type1 = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_DETAIL_ORDER_TYPE_INIT
@paypay_detail_order_type2 = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_DETAIL_ORDER_TYPE_AUTH_CAPTURE
@paypay_detail_order_type = [@paypay_detail_order_type1,@paypay_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@paypay_detail_command_type1 = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_DETAIL_COMMAND_INIT
@paypay_detail_command_type2 = Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_DETAIL_COMMAND_PRE_AUTH
@paypay_detail_command_type = [@paypay_detail_command_type1,@paypay_detail_command_type2]

#=================================================
# PayPayサービスタイプ
#=================================================
@paypay_service_type = [Veritrans::Tercerog::Mdk::MdkConst::PAYPAY_ONLINE]

@paypay_parameters = Veritrans::Tercerog::Mdk::PaypaySearchParameter.new
@paypay_parameters.detail_order_type = @paypay_detail_order_type
@paypay_parameters.detail_command_type = @paypay_detail_command_type
@paypay_parameters.paypay_service_type = @paypay_service_type

#=================================================
# Amazon Pay固有検索パラメータ
#  AmazonpaySearchParameter
#=================================================

#=================================================
# 詳細オーダー決済状態
#=================================================
@amazonpay_detail_order_type1 = "Init"
@amazonpay_detail_order_type2 = "Auth"
@amazonpay_detail_order_type = [@amazonpay_detail_order_type1,@amazonpay_detail_order_type2]

#=================================================
# 詳細コマンドタイプ名
#=================================================
@amazonpay_detail_command_type1 = "Init"
@amazonpay_detail_command_type2 = "PreAuth"
@amazonpay_detail_command_type3 = "AuthCapture"
@amazonpay_detail_command_type4 = "VoidAuthCapture"
@amazonpay_detail_command_type = [@amazonpay_detail_command_type1,@amazonpay_detail_command_type2,@amazonpay_detail_command_type3,@amazonpay_detail_command_type4]

#=================================================
# 決済センターの管理ID
#=================================================
@amazonpay_center_order_id = "12345678"

#=================================================
# 決済センターのトランザクション管理ID
#=================================================
@amazonpay_center_transaction_id = "12345678"

@amazonpay_parameters = Veritrans::Tercerog::Mdk::AmazonpaySearchParameter.new
@amazonpay_parameters.detail_order_type = @amazonpay_detail_order_type
@amazonpay_parameters.detail_command_type = @amazonpay_detail_command_type
@amazonpay_parameters.center_order_id = @amazonpay_center_order_id
@amazonpay_parameters.center_transaction_id = @amazonpay_center_transaction_id

#=================================================
# 本人認証固有検索パラメータ
#=================================================

#=================================================
# 詳細オーダー決済状態
#=================================================
@mpi_detail_order_type1 = "auth"
@mpi_detail_order_type = [@mpi_detail_order_type1]

#=================================================
# 応答3DトランザクションID
#=================================================
@mpi_res3dTransactionId = "12345678"

#=================================================
# 応答3Dトランザクションステータス
#=================================================
@mpi_res3dTransactionStatus = "12345678"

#=================================================
# 応答3D ECI
#=================================================
@mpi_res3dEci = "01"

#=================================================
# デバイスチャネル
#=================================================
@mpi_deviceChannel1 = "02"
@mpi_deviceChannel = [@mpi_deviceChannel1]

#=================================================
# アカウントタイプ
#=================================================
@mpi_accountType1 = "01"
@mpi_accountType = [@mpi_accountType1]

@mpi_parameters = Veritrans::Tercerog::Mdk::MpiSearchParameter.new
@mpi_parameters.detail_order_type = @mpi_detail_order_type
@mpi_parameters.res3d_transaction_id = @mpi_res3dTransactionId
@mpi_parameters.res3d_transaction_status = @mpi_res3dTransactionStatus
@mpi_parameters.res3d_eci = @mpi_res3dEci
@mpi_parameters.device_channel = @mpi_deviceChannel
@mpi_parameters.account_type = @mpi_accountType

#=================================================
# 取引結果検索条件設定
# 対象サービスの検索パラメータを必要に応じてセット
#=================================================
@search_target_condition = Veritrans::Tercerog::Mdk::SearchParameters.new
@search_target_condition.common = @common_parameters
# for 電子マネー決済取引
# @search_target_condition.em = @em_parameters
# for コンビニ決済取引
# @search_target_condition.cvs = @cvs_parameters
# for PayEasy決済取引
# @search_target_condition.bank = @bank_parameters
# for PayPal決済取引
# @search_target_condition.paypal = @paypal_parameters
# for Saison決済取引
# @search_target_condition.saison = @saison_parameters
# for 銀聯ネット決済（UPOP）取引
# @search_target_condition.upop = @upop_parameters
# for Alipay取引
# @search_target_condition.alipay = @alipay_parameters
# for キャリア決済取引
# @search_target_condition.carrier = @carrier_parameters
# for ショッピングクレジット決済取引
# @search_target_condition.oricosc = @oricosc_parameters
# for 楽天ID決済取引
# @search_target_condition.rakuten = @rakuten_parameters
# for リクルートかんたん支払い決済取引
# @search_target_condition.recruit = @recruit_parameters
# for LINE Pay取引
# @search_target_condition.linepay = @linepay_parameters
# for MasterPass取引
# @search_target_condition.masterpass = @masterpass_parameters
# for 銀行振込決済取引
# @search_target_condition.virtualacc = @virtualacc_parameters
# for PayPay取引
# @search_target_condition.paypay = @paypay_parameters
# for Amazon Pay取引
# @search_target_condition.amazonpay = @amazonpay_parameters
# for 本人認証取引
# @search_target_condition.mpi = @mpi_parameters

#=================================================
# 取引結果検索条件を要求電文パラメータへ設定
#=================================================
@request_data.search_parameters = @search_target_condition

#=================================================
# 検索実行
#=================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#=================================================
# 結果コード取得
#=================================================
@txn_status = @response_data.mstatus

#=================================================
# 詳細コード取得
#=================================================
@txn_result_code = @response_data.v_result_code

#=================================================
# エラーメッセージ取得
#=================================================
@error_message = @response_data.merr_msg

#=================================================
# 結果表示
#=================================================
if 'pending' == @txn_status
  # ペンディング
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "Check log file for more information"

elsif 'failure' == @txn_status
  # 失敗
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "Check log file for more information"

elsif 'success' == @txn_status
  # 成功
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Search Count]: #{@response_data.search_count}"

  if 'true' == @response_data.over_max_count_flag
    puts "Over Search Max Count"
  end
  if @response_data.search_count != "0"

    #=================================================
    # 検索結果内オーダ情報
    #=================================================
    @orders = @response_data.order_infos.order_info
    puts "----- Search Results -----"
    for @order in @orders
      puts "*---------**---------*"
      puts "Index: " + @order.index.to_s
      puts "Service Type: " + @order.service_type_cd.to_s
      puts "Order ID: " + @order.order_id.to_s
      puts "Order Status: " + @order.order_status.to_s

      #=================================================
      # オーダ情報区分チェック
      #=================================================
      case @order.service_type_cd
      when 'card'
        @is_card = "true"
      when  'em'
        @is_em = "true"
      when  'cvs'
        @is_cvs = "true"
      when  'bank'
        @is_bank = "true"
      when  'paypal'
        @is_paypal = "true"
      when 'upop'
        @is_upop = "true"
      when 'alipay'
        @is_alipay = "true"
      when  'carrier'
        @is_carrier = "true"
      when 'oricosc'
        @is_oricosc = "true"
      when 'rakuten'
        @is_rakuten = "true"
      when 'recruit'
        @is_recruit = "true"
      when 'linepay'
        @is_linepay = "true"
      when 'masterpass'
        @is_masterpass = "true"
      when 'virtualacc'
        @is_virtualacc = "true"
      when 'paypay'
        @is_paypay = "true"
      when 'amazonpay'
          @is_amazonpay = "true"
      when 'mpi'
        @is_mpi = "true"
      else
        puts "[Error] Undefined Service Transaction"
        puts "Contact to support"
      end
      
      #=================================================
      # 固有オーダ情報（サービス別）
      # サンプルでは、カード決済・楽天・リクルート・LINE PAY・MasterPassの例を実装しています
      #=================================================
      @proper_order_info = @order.proper_order_info
      if is_true(@is_card)
        puts "Card Transaction ID: " + @proper_order_info.start_txn.to_s
        puts "Currency: " + @proper_order_info.request_currency_unit.to_s

      elsif is_true(@is_rakuten)
        puts "With Capture: " + @proper_order_info.with_capture.to_s
        puts "Item name: " + @proper_order_info.item_name.to_s
        puts "Item ID: " + @proper_order_info.item_id.to_s
        puts "Authorize Amount: " + @proper_order_info.authorize_amount.to_s
        puts "Balance: " + @proper_order_info.balance.to_s
        puts "Authorize Datetime: " + @proper_order_info.authorize_datetime.to_s
        puts "Rakuten Order Id: " + @proper_order_info.rakuten_order_id.to_s
        puts "Used Point: " + @proper_order_info.used_point.to_s
        puts "Gateway Order Id: " + @proper_order_info.gateway_order_id.to_s
        puts "Card Brand: " + @proper_order_info.card_brand.to_s
        puts "Card Last4: " + @proper_order_info.card_last4.to_s
        puts "Card Installments: " + @proper_order_info.card_installments.to_s
        puts "Card Cvc: " + @proper_order_info.card_cvc.to_s
        puts "Card 3ds: " + @proper_order_info.card3ds.to_s
        puts "Cancel Expiration Time: " + @proper_order_info.cancel_expiration_time.to_s
        puts "Capture Expiration Time: " + @proper_order_info.capture_expiration_time.to_s
        puts "Update Expiration Time: " + @proper_order_info.update_expiration_time.to_s
        puts "Extend Auth Expiration Time: " + @proper_order_info.extend_auth_expiration_time.to_s
        puts "Accounting Type: " + @proper_order_info.accounting_type.to_s
        puts "Consent Status: " + @proper_order_info.consent_status.to_s
        puts "Original Order Id: " + @proper_order_info.original_order_id.to_s
        puts "Rakuten Consent Order Id: " + @proper_order_info.rakuten_consent_order_id.to_s
        puts "Customer Id: " + @proper_order_info.customer_id.to_s

      elsif is_true(@is_recruit)
        puts "With Capture: " + @proper_order_info.with_capture.to_s
        puts "Item name: " + @proper_order_info.item_name.to_s
        puts "Item ID: " + @proper_order_info.item_id.to_s
        puts "Authorize Amount: " + @proper_order_info.authorize_amount.to_s
        puts "Balance: " + @proper_order_info.balance.to_s
        puts "Authorize Datetime: " + @proper_order_info.authorize_datetime.to_s
        puts "Recruit Order Id: " + @proper_order_info.recruit_order_id.to_s

      elsif is_true(@is_linepay)
        puts "With Capture: " + @proper_order_info.with_capture.to_s
        puts "Item name: " + @proper_order_info.item_name.to_s
        puts "Item ID: " + @proper_order_info.item_id.to_s
        puts "Authorize Amount: " + @proper_order_info.authorize_amount.to_s
        puts "Balance: " + @proper_order_info.balance.to_s
        puts "Authorize Datetime: " + @proper_order_info.authorize_datetime.to_s
        puts "Linepay Order Id: " + @proper_order_info.linepay_order_id.to_s

      elsif is_true(@is_masterpass)
        puts "With Capture: " + @proper_order_info.with_capture.to_s
        puts "Item ID: " + @proper_order_info.item_id.to_s
        puts "Item Amount: " + @proper_order_info.item_amount.to_s
        puts "Authorize Amount: " + @proper_order_info.authorize_amount.to_s
        puts "Authorize Datetime: " + @proper_order_info.authorize_datetime.to_s
        puts "Masterpass Order Id: " + @proper_order_info.masterpass_order_id.to_s
        puts "Card Order Id: " + @proper_order_info.card_order_id.to_s
        puts "Acquirer Code: " + @proper_order_info.acquirer_code.to_s
        puts "Card Number: " + @proper_order_info.card_number.to_s

      elsif is_true(@is_virtualacc)
        puts "Total Deposit Amount: " + @proper_order_info.total_deposit_amount.to_s
        puts "Entry Transfer Name: " + @proper_order_info.entry_transfer_name.to_s
        puts "Entry Transfer Number: " + @proper_order_info.entry_transfer_number.to_s
        puts "Accounting Type: " + @proper_order_info.accounting_type.to_s
        puts "Account Manage Type: " + @proper_order_info.account_manage_type.to_s

      elsif is_true(@is_paypay)
        puts "Paypay Order Id: " + @proper_order_info.paypay_order_id.to_s
        puts "Paypay Service Type: " + @proper_order_info.paypay_service_type.to_s
        puts "Authorize Amount: " + @proper_order_info.authorize_amount.to_s
        puts "Balance: " + @proper_order_info.balance.to_s
        puts "Authorize Datetime: " + @proper_order_info.authorize_datetime.to_s
        puts "Refund Datetime: " + @proper_order_info.refund_datetime.to_s
        puts "Capture Datetime: " + @proper_order_info.capture_datetime.to_s
        puts "Cancel Datetime: " + @proper_order_info.cancel_datetime.to_s
        puts "With Capture: " + @proper_order_info.with_capture.to_s
        puts "Item Id: " + @proper_order_info.item_id.to_s

      elsif is_true(@is_amazonpay)
        puts "Authorize Amount: " + @proper_order_info.authorize_amount.to_s
        puts "Capture Amount: " + @proper_order_info.capture_amount.to_s
        puts "Refundable Amount: " + @proper_order_info.refundable_amount.to_s
        puts "Balance: " + @proper_order_info.balance.to_s
        puts "Authorize Datetime: " + @proper_order_info.authorize_datetime.to_s
        puts "Center Order Id: " + @proper_order_info.center_order_id.to_s

      elsif is_true(@is_mpi)
        puts "Start Txn: " + @proper_order_info.start_txn.to_s
        puts "Ddd Message Version: " + @proper_order_info.ddd_message_version.to_s
        puts "Request Currency Unit: " + @proper_order_info.request_currency_unit.to_s
        puts "Card Expire: " + @proper_order_info.card_expire.to_s
        puts "Device Channel: " + @proper_order_info.device_channel.to_s
        puts "Account Type: " + @proper_order_info.account_type.to_s

      end

      #=================================================
      # 取引情報
      #=================================================
      @order_transactions = @order.transaction_infos.transaction_info
      for @order_transaction in @order_transactions
        puts "----"
        puts "Transaction ID: " + @order_transaction.txn_id.to_s
        puts "Executed Command: " + @order_transaction.command.to_s
        puts "Transaction Status: " + @order_transaction.mstatus.to_s
        puts "Transaction Result Code: " + @order_transaction.v_result_code.to_s
        puts "Execute Time: " + @order_transaction.txn_datetime.to_s
        puts "Settlement Amount: " + @order_transaction.amount.to_s

        @proper_transaction_info = @order_transaction.proper_transaction_info
        if @proper_transaction_info.nil?
          @notice_message = "[Notice] Proper Transaction Info Unavailable"
          next

        elsif is_true(@is_card)
          puts "Card Transaction Type: " + @proper_transaction_info.card_transaction_type.to_s
          puts "Gateway Request Date: " + @proper_transaction_info.gateway_request_date.to_s
          puts "Gateway Response Date: " + @proper_transaction_info.gateway_response_date.to_s
          puts "Center Request Date: " + @proper_transaction_info.center_request_date.to_s
          puts "Center Response Date: " + @proper_transaction_info.center_response_date.to_s
          puts "Center Request Number: " + @proper_transaction_info.center_request_number.to_s
          puts "Center Reference Number: " + @proper_transaction_info.center_reference_number.to_s
          puts "Request Auth Code: " + @proper_transaction_info.req_auth_code.to_s

        elsif is_true(@is_rakuten)
          puts "Rakuten API Error Code: " + @proper_transaction_info.rakuten_api_error_code.to_s
          puts "Rakuten API Error Type: " + @proper_transaction_info.rakuten_api_error_type.to_s
          puts "Rakuten Order Error Code: " + @proper_transaction_info.rakuten_order_error_code.to_s
          puts "Rakuten Request Datetime: " + @proper_transaction_info.rakuten_request_datetime.to_s
          puts "Rakuten Response Datetime: " + @proper_transaction_info.rakuten_response_datetime.to_s

        elsif is_true(@is_recruit)
          puts "Recruit Error Code: " + @proper_transaction_info.recruit_error_code.to_s
          puts "Recruit Request Datetime: " + @proper_transaction_info.recruit_request_datetime.to_s
          puts "Recruit Response Datetime: " + @proper_transaction_info.recruit_response_datetime.to_s

        elsif is_true(@is_linepay)
          puts "Linepay Error Code: " + @proper_transaction_info.linepay_error_code.to_s
          puts "Linepay Request Datetime: " + @proper_transaction_info.linepay_request_datetime.to_s
          puts "Linepay Response Datetime: " + @proper_transaction_info.linepay_response_datetime.to_s

        elsif is_true(@is_masterpass)
          puts "Masterpass AuthCode: " + @proper_transaction_info.auth_code.to_s
          puts "Masterpass ReferenceNumber: " + @proper_transaction_info.reference_number.to_s
          puts "Masterpass DetailCommandType: " + @proper_transaction_info.detail_command_type.to_s
          puts "Masterpass CardVResultCode: " + @proper_transaction_info.card_v_result_code.to_s
          puts "Masterpass Request Datetime: " + @proper_transaction_info.masterpass_request_datetime.to_s
          puts "Masterpass Response Datetime: " + @proper_transaction_info.masterpass_response_datetime.to_s

        elsif is_true(@is_virtualacc)
          puts "Virtualacc With Reconcile: " + @proper_transaction_info.with_reconcile.to_s
          puts "Virtualacc Deposit Id: " + @proper_transaction_info.deposit_id.to_s
          puts "Virtualacc Registration Method: " + @proper_transaction_info.registration_method.to_s
          puts "Virtualacc Deposit Date: " + @proper_transaction_info.deposit_date.to_s
          puts "Virtualacc Transfer Name: " + @proper_transaction_info.transfer_name.to_s

        elsif is_true(@is_upop)
          puts "UPOP Settle Amount: " + @proper_transaction_info.res_upop_settle_amount.to_s
          puts "UPOP Settle Date: " + @proper_transaction_info.res_upop_settle_date.to_s
          puts "UPOP Settle Currency: " + @proper_transaction_info.res_upop_settle_currency.to_s
          puts "UPOP Exchange Date: " + @proper_transaction_info.res_upop_exchange_date.to_s
          puts "UPOP Exchange Rate: " + @proper_transaction_info.res_upop_exchange_rate.to_s
          puts "UPOP Upop Order Id: " + @proper_transaction_info.res_upop_order_id.to_s

        elsif is_true(@is_alipay)
          puts "Alipay Center Trade Id: " + @proper_transaction_info.center_trade_id.to_s
          puts "Alipay Txn Type: " + @proper_transaction_info.alipay_txn_type.to_s
          puts "Alipay Settle Amount: " + @proper_transaction_info.settle_amount.to_s
          puts "Alipay Settle Currency: " + @proper_transaction_info.settle_currency.to_s
          puts "Alipay Payment Time: " + @proper_transaction_info.payment_time.to_s
          puts "Alipay Settlement Time: " + @proper_transaction_info.settlement_time.to_s
          puts "Alipay Pay Type: " + @proper_transaction_info.pay_type.to_s

        elsif is_true(@is_paypay)
          puts "Paypay Paypay Result Code: " + @proper_transaction_info.paypay_result_code.to_s
          puts "Paypay Detail Command Type: " + @proper_transaction_info.detail_command_type.to_s
          puts "Paypay Item Name: " + @proper_transaction_info.item_name.to_s
          puts "Paypay Request Datetime: " + @proper_transaction_info.paypay_request_datetime.to_s
          puts "Paypay Response Datetime: " + @proper_transaction_info.paypay_response_datetime.to_s
          puts "Paypay Online Txn Id: " + @proper_transaction_info.paypay_online_txn_id.to_s
          puts "Paypay Error Code: " + @proper_transaction_info.paypay_error_code.to_s

        elsif is_true(@is_amazonpay)
          puts "Amazonpay Center Transaction Id: " + @proper_transaction_info.center_transaction_id.to_s
          puts "Amazonpay Center Result Code: " + @proper_transaction_info.center_result_code.to_s
          puts "Amazonpay Center State Code: " + @proper_transaction_info.center_state_code.to_s
          puts "Amazonpay Center Reason Code: " + @proper_transaction_info.center_reason_code.to_s
          puts "Amazonpay Detail Command Type: " + @proper_transaction_info.detail_command_type.to_s
          puts "Amazonpay Center Request Datetime: " + @proper_transaction_info.center_request_datetime.to_s
          puts "Amazonpay Center Response Datetime: " + @proper_transaction_info.center_response_datetime.to_s

        elsif is_true(@is_mpi)
          # 本人認証固有
          puts "Mpi Txn Kind: " + @proper_transaction_info.txn_kind.to_s
          puts "Mpi Mpi Transaction Type: " + @proper_transaction_info.mpi_transaction_type.to_s
          puts "Mpi Req Card Number: " + @proper_transaction_info.req_card_number.to_s
          puts "Mpi Req Card Expire: " + @proper_transaction_info.req_card_expire.to_s
          puts "Mpi Req Amount: " + @proper_transaction_info.req_amount.to_s
          puts "Mpi Req Redirection Uri: " + @proper_transaction_info.req_redirection_uri.to_s
          puts "Mpi Corporation Id: " + @proper_transaction_info.corporation_id.to_s
          puts "Mpi Brand Id: " + @proper_transaction_info.brand_id.to_s
          puts "Mpi Acquirer Binary: " + @proper_transaction_info.acquirer_binary.to_s
          puts "Mpi Ds Login Id: " + @proper_transaction_info.ds_login_id.to_s
          puts "Mpi Crres Status: " + @proper_transaction_info.crres_status.to_s
          puts "Mpi Veres Status: " + @proper_transaction_info.veres_status.to_s
          puts "Mpi Pares Sign: " + @proper_transaction_info.pares_sign.to_s
          puts "Mpi Pares Status: " + @proper_transaction_info.pares_status.to_s
          puts "Mpi Pares Eci: " + @proper_transaction_info.pares_eci.to_s
          puts "Mpi Auth Response Code: " + @proper_transaction_info.auth_response_code.to_s
          puts "Mpi Verify Response Code: " + @proper_transaction_info.verify_response_code.to_s
          puts "Mpi Res3d Message Version: " + @proper_transaction_info.res3d_message_version.to_s
          puts "Mpi Res3d Transaction Id: " + @proper_transaction_info.res3d_transaction_id.to_s
          puts "Mpi Res3d Ds Transaction Id: " + @proper_transaction_info.res3d_ds_transaction_id.to_s
          puts "Mpi Res3d Server Transaction Id: " + @proper_transaction_info.res3d_server_transaction_id.to_s
          puts "Mpi Res3d Transaction Status: " + @proper_transaction_info.res3d_transaction_status.to_s
          puts "Mpi Res3d Cavv Algorithm: " + @proper_transaction_info.res3d_cavv_algorithm.to_s
          puts "Mpi Res3d Cavv: " + @proper_transaction_info.res3d_cavv.to_s
          puts "Mpi Res3d Eci: " + @proper_transaction_info.res3d_eci.to_s
          puts "Mpi Auth Request Datetime: " + @proper_transaction_info.auth_request_datetime.to_s
          puts "Mpi Auth Response Datetime: " + @proper_transaction_info.auth_response_datetime.to_s
          puts "Mpi Verify Request Datetime: " + @proper_transaction_info.verify_request_datetime.to_s
          puts "Mpi Verify Response Datetime: " + @proper_transaction_info.verify_response_datetime.to_s
          puts "Mpi Req Currency Unit: " + @proper_transaction_info.req_currency_unit.to_s
          puts "Mpi Req Acquirer Code: " + @proper_transaction_info.req_acquirer_code.to_s
          puts "Mpi Req Item Code: " + @proper_transaction_info.req_item_code.to_s
          puts "Mpi Req Card Center: " + @proper_transaction_info.req_card_center.to_s
          puts "Mpi Req Jpo Information: " + @proper_transaction_info.req_jpo_information.to_s
          puts "Mpi Req Sales Day: " + @proper_transaction_info.req_sales_day.to_s
          puts "Mpi Req With Capture: " + @proper_transaction_info.req_with_capture.to_s
          puts "Mpi Req Security Code: " + @proper_transaction_info.req_security_code.to_s
          puts "Mpi Req Birthday: " + @proper_transaction_info.req_birthday.to_s
          puts "Mpi Req Tel: " + @proper_transaction_info.req_tel.to_s
          puts "Mpi Req First Kana Name: " + @proper_transaction_info.req_first_kana_name.to_s
          puts "Mpi Req Last Kana Name: " + @proper_transaction_info.req_last_kana_name.to_s
          # カード固有
          puts "Mpi Txn Kind: " + @proper_transaction_info.txn_kind.to_s
          puts "Mpi Card Transaction Type: " + @proper_transaction_info.card_transaction_type.to_s
          puts "Mpi Gateway Request Date: " + @proper_transaction_info.gateway_request_date.to_s
          puts "Mpi Gateway Response Date: " + @proper_transaction_info.gateway_response_date.to_s
          puts "Mpi Center Request Date: " + @proper_transaction_info.center_request_date.to_s
          puts "Mpi Center Response Date: " + @proper_transaction_info.center_response_date.to_s
          puts "Mpi Center Request Number: " + @proper_transaction_info.center_request_number.to_s
          puts "Mpi Center Reference Number: " + @proper_transaction_info.center_reference_number.to_s
          puts "Mpi Req Item Code: " + @proper_transaction_info.req_item_code.to_s
          puts "Mpi Res Item Code: " + @proper_transaction_info.res_item_code.to_s
          puts "Mpi Req Return Reference Number: " + @proper_transaction_info.req_return_reference_number.to_s
          puts "Mpi Responsedata: " + @proper_transaction_info.responsedata.to_s
          puts "Mpi Pending: " + @proper_transaction_info.pending.to_s
          puts "Mpi Loopback: " + @proper_transaction_info.loopback.to_s
          puts "Mpi Connected Center Id: " + @proper_transaction_info.connected_center_id.to_s
          puts "Mpi Req Card Number: " + @proper_transaction_info.req_card_number.to_s
          puts "Mpi Req Card Expire: " + @proper_transaction_info.req_card_expire.to_s
          puts "Mpi Req Amount: " + @proper_transaction_info.req_amount.to_s
          puts "Mpi Req Card Option Type: " + @proper_transaction_info.req_card_option_type.to_s
          puts "Mpi Req Merchant Transaction: " + @proper_transaction_info.req_merchant_transaction.to_s
          puts "Mpi Req Auth Code: " + @proper_transaction_info.req_auth_code.to_s
          puts "Mpi Req Acquirer Code: " + @proper_transaction_info.req_acquirer_code.to_s
          puts "Mpi Req Card Center: " + @proper_transaction_info.req_card_center.to_s
          puts "Mpi Req Jpo Information: " + @proper_transaction_info.req_jpo_information.to_s
          puts "Mpi Req Sales Day: " + @proper_transaction_info.req_sales_day.to_s
          puts "Mpi Req Cancel Day: " + @proper_transaction_info.req_cancel_day.to_s
          puts "Mpi Req With Capture: " + @proper_transaction_info.req_with_capture.to_s
          puts "Mpi Req With Direct: " + @proper_transaction_info.req_with_direct.to_s
          puts "Mpi Req3d Message Version: " + @proper_transaction_info.req3d_message_version.to_s
          puts "Mpi Req3d Transaction Id: " + @proper_transaction_info.req3d_transaction_id.to_s
          puts "Mpi Req3d Transaction Status: " + @proper_transaction_info.req3d_transaction_status.to_s
          puts "Mpi Req3d Cavv Algorithm: " + @proper_transaction_info.req3d_cavv_algorithm.to_s
          puts "Mpi Req3d Cavv: " + @proper_transaction_info.req3d_cavv.to_s
          puts "Mpi Req3d Eci: " + @proper_transaction_info.req3d_eci.to_s
          puts "Mpi Req3d Ds Transaction Id: " + @proper_transaction_info.req3d_ds_transaction_id.to_s
          puts "Mpi Req3d Server Transaction Id: " + @proper_transaction_info.req3d_server_transaction_id.to_s
          puts "Mpi Req Security Code: " + @proper_transaction_info.req_security_code.to_s
          puts "Mpi Req Auth Flag: " + @proper_transaction_info.req_auth_flag.to_s
          puts "Mpi Req Birthday: " + @proper_transaction_info.req_birthday.to_s
          puts "Mpi Req Tel: " + @proper_transaction_info.req_tel.to_s
          puts "Mpi Req First Kana Name: " + @proper_transaction_info.req_first_kana_name.to_s
          puts "Mpi Req Last Kana Name: " + @proper_transaction_info.req_last_kana_name.to_s
          puts "Mpi Res Merchant Transaction: " + @proper_transaction_info.res_merchant_transaction.to_s
          puts "Mpi Res Return Reference Number: " + @proper_transaction_info.res_return_reference_number.to_s
          puts "Mpi Res Auth Code: " + @proper_transaction_info.res_auth_code.to_s
          puts "Mpi Res Action Code: " + @proper_transaction_info.res_action_code.to_s
          puts "Mpi Res Center Error Code: " + @proper_transaction_info.res_center_error_code.to_s
          puts "Mpi Res Auth Term: " + @proper_transaction_info.res_auth_term.to_s
          puts "Mpi Req With New: " + @proper_transaction_info.req_with_new.to_s
          puts "Mpi Jpy Amount: " + @proper_transaction_info.jpy_amount.to_s
          puts "Mpi Res Mcp Response Code: " + @proper_transaction_info.res_mcp_response_code.to_s
          
        end
      end
    end
  end
end

#puts @response_data.to_string
