# encoding: utf-8
#
# 銀聯ネット決済(UPOP) 返金要求サンプル
#

#
# MDKへパスを通す
#
require './MdkRuby/tgMdk/lib/tg_mdk'
require './MdkRuby/tgMdk/lib/tg_mdk/mdk_dto'

#-------------------------------------------------------
# 取引ID
#-------------------------------------------------------
# 売上完了または部分返金状態の取引IDを指定します
@order_id = "change_order_id"

#-------------------------------------------------------
# 支払金額
#-------------------------------------------------------
@amount = "5"


#==========================================================================
#  要求電文パラメータ値の指定
#==========================================================================
@request_data = Veritrans::Tercerog::Mdk::UpopRefundRequestDto.new
@request_data.order_id = @order_id.to_s
@request_data.amount = @amount.to_s


#==========================================================================
# 実施
#==========================================================================
tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
@response_data = tran.execute(@request_data)

#
# 結果コード取得
#
@txn_status = @response_data.mstatus
#
# 詳細コード取得
#
@txn_result_code = @response_data.v_result_code
#
# エラーメッセージ取得
#
@error_message = @response_data.merr_msg


#==========================================================================
# 結果表示
#==========================================================================
# 成功
if "success" == @txn_status
  puts "...Transaction Successfully Complete"
  puts "[Status]: #{@txn_status}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "[Txn Datetime Jp]: #{@response_data.txn_datetime_jp}"
  puts "[Txn Datetime Cn]: #{@response_data.txn_datetime_cn}"
  puts "[Captured Amount]: #{@response_data.captured_amount}"
  puts "[Remaining Amount]: #{@response_data.remaining_amount}"
  puts "[Settle Amount]: #{@response_data.settle_amount}"
  puts "[Settle Date]: #{@response_data.settle_date}"
  puts "[Settle Currency]: #{@response_data.settle_currency}"
  puts "[Settle Rate]: #{@response_data.settle_rate}"
  puts "[Upop Order Id]: #{@response_data.upop_order_id}"
end
# ペンディング
if "pending" == @txn_status
  puts "...Transaction Pending"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end
# 失敗
if "failure" == @txn_status
  puts "...Transaction Failure"
  puts "[Status]: #{@txn_status}"
  puts "[Message]: #{@error_message}"
  puts "[Result Code]: #{@txn_result_code}"
  puts "[Order ID]: #{@response_data.order_id}"
  puts "Check log file for more information"
end

#puts @response_data.to_string
