class Web::Alipay::ConfirmController < ApplicationController
  include MdkValidation

  #-------------------------------------------------------------------------
  # Alipay確認サンプル
  #-------------------------------------------------------------------------
  def execute
    @err_msg = validate_alipay_confirm
    unless @err_msg.blank?
      render :action => :index
    return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::AlipayConfirmRequestDto.new
    req.order_id = params[:orderId].to_s
    req.response_type = params[:responseType].to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @cust_txn = res.cust_txn
    @center_trade_id = res.center_trade_id
    @pay_time_jp = res.pay_time_jp
    @pay_time_cn = res.pay_time_cn
    @buyer_charged_amount_cny = res.buyer_charged_amount_cny
  end
end
