# -*- encoding: utf-8 -*-
class Web::Amazonpay::GetAddressController < ApplicationController

  #-------------------------------------------------------------------------
  # Amazon Pay 住所情報取得要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::AmazonpayGetAddressRequestDto.new
    req.order_id = @order_id.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @center_response_datetime = res.center_response_datetime
    @shipping_name = res.shipping_name
    @shipping_phone = res.shipping_phone
    @shipping_address1 = res.shipping_address1
    @shipping_address2 = res.shipping_address2
    @shipping_address3 = res.shipping_address3
    @shipping_prefecture = res.shipping_prefecture
    @shipping_postal_code = res.shipping_postal_code
  end
end
