# -*- encoding: utf-8 -*-
class Web::Card::ReAuthorizeController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
  end

  #-------------------------------------------------------------------------
  # クレジットカード決済 再与信要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 元取引ID
    @original_order_id = params[:original_order_id]
    # 支払金額
    @amount = params[:amount]
    # 与信方法
    @with_capture = params[:with_capture]
    if @with_capture == "1"
      @is_with_capture = "true"
    else
      @is_with_capture = "false"
    end
    # 支払オプション
    @jpo1=params[:jpo1]
    @jpo2=params[:jpo2]
    unless @jpo1.blank?
      if "10" == @jpo1 || "80" == @jpo1
        @jpo =  @jpo1
      elsif "61" == @jpo1 && !@jpo2.empty?
        @jpo =  @jpo1 + "C" + @jpo2
      end
    end
    # セキュリティコード
    @security_code = params[:security_code]


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message += "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/>"
    end
    if @original_order_id == ""
      @error_message += "<font color='#ff0000'><b>必須項目：元取引IDが指定されていません</b></font><br/>"
    end
    if @amount == ""
      @error_message += "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/>"
    end
    if @error_message != ""
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::CardReAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.original_order_id = @original_order_id.to_s
    req.amount = @amount.to_s
    req.with_capture = @is_with_capture.to_s
    unless @jpo.blank?
      req.jpo = @jpo.to_s
    end
    unless @security_code.blank?
      req.security_code = @security_code.to_s
    end


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @req_card_number = res.req_card_number
    @center_reference_number = res.center_reference_number
  end
end
