# -*- encoding: utf-8 -*-
class Web::Em::RefundController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
  end

  #-------------------------------------------------------------------------
  # 電子マネー返金サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 決済方式
    @service_option_type = params[:service_option_type]
    # 本取引の取引ID
    @order_id = Time.now.to_i
    # 返金依頼金額  <= 決済金額
    @amount = params[:amount]
    # オーダー種別
    @order_kind = params[:order_kind]
    # 返金対象取引ID
    @refund_order_id = params[:refund_order_id]
    # 決済期限
    @settlement_limit = params[:settlement_limit]
    # 画面タイトル
    @screen_title = params[:screen_title]
    # 決済アプリケーション起動URL
    @app_url ||= ''


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @order_kind == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引種別が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @refund_order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：返金対象取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @service_option_type != "edy-mobile" \
      && @service_option_type != "edy-pc" \
      && @service_option_type != "edy-direct" \
      && @service_option_type != "waon-pc" \
      && @service_option_type != "waon-mobile" \
      && @settlement_limit == ""
      @error_message = "<font color='#ff0000'><b>必須項目：決済期限が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::EmRefundRequestDto.new
    req.service_option_type = @service_option_type
    req.order_id = @order_id.to_s
    req.order_kind = @order_kind.to_s
    req.amount = @amount.to_s
    req.refund_order_id = @refund_order_id.to_s

    if /^suica.*/m =~  @service_option_type
      # Suica決済の場合
      req.screen_title = @screen_title.to_s

    elsif "waon-pc" == @service_option_type
      # WAON PaSoRi決済の場合
      # サンプルのためダミーURLを設定
      req.success_url = "http://127.0.0.1/web/PaymentMethodSelect?status=success"
      req.failure_url = "http://127.0.0.1/web/PaymentMethodSelect?status=failure"
      req.cancel_url = "http://127.0.0.1/web/PaymentMethodSelect?status=cancel"
    end

    if @service_option_type != "edy-mobile" \
      && @service_option_type != "edy-pc" \
      && @service_option_type != "edy-direct" \
      && @service_option_type != "waon-pc" \
      && @service_option_type != "waon-mobile"
      req.settlement_limit = @settlement_limit.to_s
    end


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @receipt_no = res.receipt_no
    @app_url = res.app_url
  end
end
