# -*- encoding: utf-8 -*-
class Web::Em::RemoveController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
  end

  #-------------------------------------------------------------------------
  # 電子マネー決済要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 決済方式
    @service_option_type = params[:service_option_type]
    # 取引ID
    @order_id = params[:order_id]
    # ユーザID
    @user_id = params[:user_id]


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @user_id == ""
      if @service_option_type == "tcc-redirect"
        @error_message = "<font color='#ff0000'><b>必須項目：ユーザIDが指定されていません</b></font><br/><br/>"
        render :action => "index"
        return
      end
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::EmRemoveRequestDto.new
    req.service_option_type = @service_option_type
    req.order_id = @order_id.to_s
    req.user_id = @user_id.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @delete_card_num = res.delete_card_num
  end
end
