# -*- encoding: utf-8 -*-
class Web::Masterpass::CancelController < ApplicationController

  #-------------------------------------------------------------------------
  # MasterPass 取消要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # Order ID(取引ID)
    @order_id = params[:order_id]
    # Amount(取消金額)
    @amount = params[:amount]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id == ""
      @error_message = "<font color='#ff0000'><b>Unset Order Id<br>(必須項目：取引IDが指定されていません)</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::MasterpassCancelRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @cancel_datetime = res.cancel_datetime
  end
end
