# -*- encoding: utf-8 -*-
class Web::Paynowid::Account::EntryController < ApplicationController

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @entry_kbn ||= ''
  end

  #-------------------------------------------------------------------------
  # 会員入会要求サンプル
  #-------------------------------------------------------------------------
  def execute
    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 会員ID
    @account_id = params[:account_id]
    # 入会年月日
    @create_date = params[:create_date]
    # 入会処理区分
    @entry_kbn = params[:entry_kbn]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = nil
    if @account_id.nil? || @account_id.empty?
      # 会員ID
      @error_message = "<font color='#ff0000'><b>必須項目：会員IDが指定されていません</b></font>"

    elsif @entry_kbn != "1" && @entry_kbn != "2"
      # 入会処理区分
      @error_message = "<font color='#ff0000'><b>不正な入会処理区分です</b></font>"
    end

    unless @error_message.nil?
      # エラーが存在する場合は入力画面に戻る。
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    if @entry_kbn == "1"
      # 新規入会の場合
      req = Veritrans::Tercerog::Mdk::AccountAddRequestDto.new
      req.account_id = @account_id.to_s
      req.create_date = @create_date.to_s

    elsif @entry_kbn == "2"
      # 再入会の場合
      req = Veritrans::Tercerog::Mdk::AccountRestoreRequestDto.new
      req.account_id = @account_id.to_s
      req.create_date = @create_date.to_s
    end


    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    if !res.pay_now_id_response.nil?
      @pay_now_id_proc_id = res.pay_now_id_response.process_id
      @pay_now_id_status = res.pay_now_id_response.status
    end
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
  end
end
