# -*- encoding: utf-8 -*-
class Web::Paypal::AuthorizeController < ApplicationController

  skip_before_action :verify_authenticity_token

  #-------------------------------------------------------------------------
  # 入力フォーム初期表示
  #-------------------------------------------------------------------------
  def index
    @order_id = "dummy" + Time.now.to_i.to_s
    @amount = params[:price].to_s
  end

  #-------------------------------------------------------------------
  # PayPal与信請求サンプル
  #-------------------------------------------------------------------
  def index_init

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    @order_id = params[:order_id]
    @amount = params[:amount]
    @payment_action = params[:payment_action]


    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    #==========================================================================
    # 必須パラメータ値チェック
    #==========================================================================
    @error_message = ""
    if @amount == ""
      @error_message = "<font color='#ff0000'><b>必須項目：決済金額が指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    # セッションに決済方法を保持
    session[:payment_action] = @payment_action

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample

    #==========================================================================
    # 要求DTOを生成し、値を設定します。
    #==========================================================================
    if session[:payment_action] == "authorize"
      req = Veritrans::Tercerog::Mdk::PaypalAuthorizeRequestDto.new
    else
      req = Veritrans::Tercerog::Mdk::PaypalCaptureRequestDto.new
    end
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    # 消費者がPaypal上での操作が完了したときの遷移するマーチャントのURLを設定します。
    req.return_url = config["PayPal"]["return_url"].to_s
    # 消費者がPaypal上で支払いをキャンセルした場合に遷移するマーチャントのURLを設定します。
    req.cancel_url = config["PayPal"]["cancel_url"].to_s
    # 配送情報有無　1：有/0:無
    req.shipping_flag = "0"
    req.action = "set"


    #==========================================================================
    # コマンドを実行し、応答DTOを取得します。
    #==========================================================================
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    if res.mstatus == "success"
      redirect_to res.login_url
    else
      #--------------------------------------------------------------------------
      # 結果画面に表示します。
      #--------------------------------------------------------------------------
      @result_order_id = res.order_id
      @mstatus = res.mstatus
      @v_result_code = res.v_result_code
      @merr_msg = res.merr_msg
    end
  end

  #==========================================================================
  # setアクションの結果を基にgetアクションを実行します
  #==========================================================================
  def comfirm

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    @token = params[:token]


    #==========================================================================
    # 要求DTOを生成し、値を設定します。
    #==========================================================================
    if session[:payment_action] == "authorize"
      req = Veritrans::Tercerog::Mdk::PaypalAuthorizeRequestDto.new
    else
      req = Veritrans::Tercerog::Mdk::PaypalCaptureRequestDto.new
    end
    req.token = @token.to_s
    req.action = "get"


    #==========================================================================
    # コマンドを実行し、応答DTOを取得します。
    #==========================================================================
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @token = res.token
    @invoice_id = res.invoice_id
    @payer_id = res.payer_id
    @amount = res.amount
    @ship_name = res.ship_name
  end

  #==========================================================================
  # doアクションを実行します ※PayPalでの取引を完了するアクション
  #==========================================================================
  def complate

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # Paypal顧客番号
    @payer_id = params[:payer_id]
    # トークン
    @token = params[:token]


    #==========================================================================
    # 要求DTOを生成し、値を設定します。
    #==========================================================================
    if session[:payment_action] == "authorize"
      req = Veritrans::Tercerog::Mdk::PaypalAuthorizeRequestDto.new
    else
      req = Veritrans::Tercerog::Mdk::PaypalCaptureRequestDto.new
    end
    req.token = @token.to_s
    req.payer_id = @payer_id.to_s
    req.action = "do"


    #==========================================================================
    # コマンドを実行し、応答DTOを取得します。
    #==========================================================================
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg

    @token = res.token
    @invoice_id = res.invoice_id
    @payer_id = res.payer_id
    @amount = res.amount
    @ship_name = res.ship_name
  end
end
