# -*- encoding: utf-8 -*-
class Web::Rakuten::UpdateAuthorizeController < ApplicationController
  #-------------------------------------------------------------------------
  # 楽天ID決済与信変更要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # 取引ID
    @order_id = params[:order_id]
    # 取引金額
    @amount = params[:amount]
    # 与信延長フラグ
    @auth_extension_flag = params[:auth_extension_flag]

    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::RakutenUpdateAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.auth_extension_flag = @auth_extension_flag.to_s

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @transaction_datetime = res.transaction_datetime
    @rakuten_order_id = res.rakuten_order_id
    @gateway_order_id = res.gateway_order_id
    @amount = res.amount
    @used_point = res.used_point
    @cancel_expiration_time = res.cancel_expiration_time
    @capture_expiration_time = res.capture_expiration_time
    @update_expiration_time = res.update_expiration_time
    @extend_auth_expiration_time = res.extend_auth_expiration_time
  end
end
