# -*- encoding: utf-8 -*-
class Web::Upop::AuthorizeController < ApplicationController
  include MdkValidation
  before_action :set_init
  skip_before_action :verify_authenticity_token  , :only => [:authorize_result]

  #-------------------------------------------------------------------------
  # UPOP決済 与信要求サンプル
  #-------------------------------------------------------------------------
  def execute

    # 取引ID
    @order_id = params[:order_id]
    # 支払金額
    @amount = params[:amount]
    # 与信同時売上
    @withCapture = params[:withCapture]
    # 戻りURL
    @termUrl = params[:termUrl]
    # 消費者のIPアドレス
    @customerIp = params[:customerIp]

    #-------------------------------------------------------------------------
    # 取引ID更新の場合の処理
    #-------------------------------------------------------------------------
    unless params[:update_id].blank?
      @order_id = "dummy" + Time.now.to_i.to_s
      render :action => "index"
      return
    end


    @err_msg = validate_upop_auth
    unless @err_msg.blank?
      render :action => :index
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::UpopAuthorizeRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.with_capture = @withCapture.to_s
    req.term_url = @termUrl.to_s
    req.customer_ip = @customerIp.to_s

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #raise res.inspect
    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @response = res
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @cust_txn = res.cust_txn

  end

  #-------------------------------------------------------------------------
  # 支払いサイトからサンプル応答
  #-------------------------------------------------------------------------
  def authorize_result
    keys = params[:authInfo].split("-")
    @auth = "1"
    if keys.size != 3
      @auth = "0"
    else
    # decode64_str - private method in application controller
      merchant_cc_id =  decode64_str(keys[0])
      gmnow  = decode64_str(keys[1])
      received_hash = decode64_str(keys[2])
      merchant_secret_key = Veritrans::Tercerog::Mdk::MdkConfig.instance.merchant_secret_key.strip
      if !received_hash.eql?(Veritrans::Tercerog::Mdk::MdkUtils::mdk_digest(merchant_cc_id + gmnow + merchant_secret_key))
        @auth = "0"
      end
    end

    @mstatus = params[:mstatus]
    @v_result_code = params[:vResultCode]
    @merr_msg = params[:merrMsg]
    @result_order_id  = params[:orderId]
    @cust_txn = params[:custTxn]
    @txn_datetime_jp = params[:txnDatetimeJp]
    @txn_datetime_cn = params[:txnDatetimeCn]
    @captured_amt = params[:capturedAmount]
    @settle_amount =  params[:settleAmount]
    @settle_date = params[:settleDate]
    @settle_currency = params[:settleCurrency]
    @settle_rate = params[:settleRate]
    @upop_order_id = params[:upopOrderId]
  end

  private

  def set_init
    @order_id = "dummy" + Time.now.to_i.to_s
    @amount = params[:price].to_s || params[:price]

    #yaml形式のconfig.ymlファイルを読み込む
    config = loadEnv4sample
    @term_url = config["UPOP"]["term_url"]
    @customer_ip = request.remote_ip
    @err_msg = ""
  end
end
