# -*- encoding: utf-8 -*-
class Web::Virtualacc::DepositEntryController < ApplicationController

  #-------------------------------------------------------------------------
  # 銀行振込決済 入金要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # Order ID(取引ID)
    @order_id = params[:order_id]
    # Amount(入金金額)
    @amount = params[:amount]
    # With Reconcile(消込フラグ)
    @with_reconcile = params[:with_reconcile]
    # Registration Method(登録方法)
    @registration_method = params[:registration_method]
    # Deposit Date(入金日)
    @deposit_date = params[:deposit_date]
    # Transfer Name(振込人名)
    @transfer_name = params[:transfer_name]


    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>Unset Order Id<br>(必須項目：取引IDが指定されていません)</b></font><br/><br/>"
      render :action => "index"
      return
    end
    if @amount.nil? || @amount.empty?
      @error_message = "<font color='#ff0000'><b>Unset Amount<br>(必須項目：金額が指定されていません)</b></font><br/><br/>"
      render :action => "index"
      return
    end


    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::VirtualaccDepositEntryRequestDto.new
    req.order_id = @order_id.to_s
    req.amount = @amount.to_s
    req.with_reconcile = @with_reconcile.to_s
    req.registration_method = @registration_method.to_s
    req.deposit_date = @deposit_date.to_s
    req.transfer_name = @transfer_name.to_s
    req.service_option_type = Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)


    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @total_deposit_amount = res.total_deposit_amount
    @deposit_id = res.deposit_id
    @order_status = res.order_status
  end
end
