# -*- encoding: utf-8 -*-
class Web::Virtualacc::DepositReverseController < ApplicationController

  #-------------------------------------------------------------------------
  # 銀行振込決済 入金取消要求サンプル
  #-------------------------------------------------------------------------
  def execute

    #-------------------------------------------------------------------------
    # パラメータを取得します。
    #-------------------------------------------------------------------------
    # Order ID(取引ID)
    @order_id = params[:order_id]
    # Deposit ID(入金ID)
    @deposit_id = params[:deposit_id]

    #-------------------------------------------------------------------------
    # 必須パラメータ値チェック
    #-------------------------------------------------------------------------
    @error_message = ""
    if @order_id.nil? || @order_id.empty?
      @error_message = "<font color='#ff0000'><b>Unset Order Id<br>(必須項目：取引IDが指定されていません)</b></font><br/><br/>"
      render :action => "index"
      return
    end

    #-------------------------------------------------------------------------
    # 要求DTOを生成し、値を設定します。
    #-------------------------------------------------------------------------
    req = Veritrans::Tercerog::Mdk::VirtualaccDepositReverseRequestDto.new
    req.order_id = @order_id.to_s
    req.deposit_id = @deposit_id.to_s
    req.service_option_type = Veritrans::Tercerog::Mdk::MdkConst::VACC_RESONA

    #-------------------------------------------------------------------------
    # コマンドを実行し、応答DTOを取得します。
    #-------------------------------------------------------------------------
    tran = Veritrans::Tercerog::Mdk::MdkTransaction.new
    res = tran.execute(req)

    #--------------------------------------------------------------------------
    # 結果画面に表示します。
    #--------------------------------------------------------------------------
    @result_order_id = res.order_id
    @mstatus = res.mstatus
    @v_result_code = res.v_result_code
    @merr_msg = res.merr_msg
    @total_deposit_amount = res.total_deposit_amount
  end
end
