# -*- encoding: utf-8 -*-
module ApplicationHelper

  def document_title_old
    if @document_title.present?
      h(@document_title) + ' - VeriTrans 4G'
    else
      'VeriTrans 4G'
    end
  end

  #-------------------------------------------------------------------------
  # 画面タイトルを取得する。
  #-------------------------------------------------------------------------
  def document_title
    titles = {
      ''                                 => '支払方法選択',
      'top'                              => '支払方法選択',
      'top/admin_menu'                   => '取引管理メニューサンプル',
      'top/paynowid_menu'                => 'PayNowIDサービス利用サンプルメニュー画面',
      'web/bank/authorize'               => '銀行決済与信サンプル画面',
      'web/card/authorize'               => 'カード決済与信サンプル画面',
      'web/card/cancel'                  => 'カード取消請求サンプル画面',
      'web/card/capture'                 => 'カード与信後売上請求サンプル画面',
      'web/card/re_authorize'            => 'カード再与信請求サンプル画面',
      'web/cvs/authorize'                => 'コンビニ決済与信サンプル画面',
      'web/cvs/cancel'                   => 'コンビニ決済取消サンプル画面',
      'web/em/authorize'                 => '電子マネー決済与信サンプル画面',
      'web/em/cancel'                    => '電子マネー取消請求サンプル画面',
      'web/em/refund'                    => '電子マネー返金請求サンプル画面',
      'web/mpi/authorize'                => 'クレジットカード決済(本人認証) 認可サンプル画面',
      'web/mpi/re_authorize'             => 'クレジットカード決済(本人認証) 再取引サンプル画面',
      'web/mpi/get_result'               => 'クレジットカード決済(本人認証) 本人認証結果確認サンプル画面',
      'web/paypal/authorize'             => 'Paypal決済与信サンプル画面',
      'web/paypal/cancel'                => 'Paypal取消請求サンプル画面',
      'web/paypal/capture'               => 'Paypal与信後売上請求サンプル画面',
      'web/paypal/refund'                => 'Paypal返金請求サンプル画面',
      'web/saison/authorize'             => '永久不滅ポイント(永久不滅ウォレット)ユーザ認可サンプル画面',
      'web/saison/cancel'                => '永久不滅ポイント(永久不滅ウォレット)取消サンプル画面',
      'web/saison/capture'               => '永久不滅ポイント(永久不滅ウォレット)売上サンプル画面',
      'web/saison/result'                => '永久不滅ポイント(永久不滅ウォレット)結果表示サンプル画面',
      'web/saison/mb/authorize'          => '永久不滅ポイント(永久不滅ウォレット)ユーザ認可サンプル画面',
      'web/saison/mb/cancel'             => '永久不滅ポイント(永久不滅ウォレット)取消サンプル画面',
      'web/saison/mb/capture'            => '永久不滅ポイント(永久不滅ウォレット)売上サンプル画面',
      'web/saison/mb/result'             => '永久不滅ポイント(永久不滅ウォレット)結果表示サンプル画面',
      'web/carrier/authorize'            => 'キャリア決済与信サンプル画面',
      'web/carrier/cancel'               => 'キャリア決済取消請求サンプル画面',
      'web/carrier/capture'              => 'キャリア決済与信後売上請求サンプル画面',
      'web/carrier/menu'                 => 'キャリア決済処理選択サンプル画面',
      'web/carrier/re_authorize'         => 'キャリア決済再与信請求サンプル画面',
      'web/carrier/result'               => '取引結果',
      'web/carrier/terminate'            => 'キャリア決済継続課金・随時決済終了サンプル画面',
      'web/carrier/mb/authorize'         => 'キャリア決済与信サンプル画面',
      'web/carrier/mb/result'            => '取引結果',
      'web/carrier/mb/terminate'         => 'キャリア決済継続課金終了サンプル画面',
      'web/oricosc/authorize'            => 'ショッピングクレジット画面表示サンプル画面',
      'web/oricosc/result'               => 'ショッピングクレジット結果表示サンプル画面',
      'web/oricosc/mb/authorize'         => 'ショッピングクレジット画面表示サンプル画面',
      'web/oricosc/mb/result'            => 'ショッピングクレジット結果表示サンプル画面',
      'web/upop/authorize'               => 'UPOP決済与信サンプル画面',
      'web/upop/result'                  => '取引結果',
      'web/upop/capture'                 => 'UPOP決済売上サンプル画面',
      'web/upop/refund'                  => 'UPOP決済返金サンプル画面',
      'web/upop/cancel'                  => 'UPOP取消サンプル画面',
      'web/alipay/authorize'             => 'Alipay決済与信サンプル画面',
      'web/alipay/result'                => '取引結果',
      'web/alipay/refund'                => 'Alipay決済返金サンプル画面',
      'web/paynowid/account/entry'       => '会員入会処理サンプル画面',
      'web/paynowid/account/withdraw'    => '会員退会処理サンプル画面',
      'web/paynowid/card/manage'         => '会員カード管理サンプル画面',
      'web/paynowid/card/and_entry'      => '決済同時会員入会サンプル画面',
      'web/paynowid/recurring/entry'     => '継続課金管理(カード払い)サンプル画面',
      'web/paynowid/recurring/terminate' => '継続課金停止(カード払い)サンプル画面',
      'web/paynowid/card/authorize'      => 'カード決済-本人認証無し(PayNowIDカード情報利用)サンプル画面',
      'web/paynowid/mpi/authorize'       => 'カード決済-3D認証無し(PayNowIDカード情報利用)サンプル画面',
      'web/rakuten/authorize'            => '楽天ID決済与信サンプル画面',
      'web/rakuten/cancel'               => '楽天ID決済取消請求サンプル画面',
      'web/rakuten/capture'              => '楽天ID決済与信後売上請求サンプル画面',
      'web/rakuten/update_authorize'     => '楽天ID決済与信変更請求サンプル画面',
      'web/rakuten/re_authorize'         => '楽天ID決済再与信サンプル画面',
      'web/recruit/authorize'            => 'リクルートかんたん支払い与信サンプル画面',
      'web/recruit/cancel'               => 'リクルートかんたん支払い取消請求サンプル画面',
      'web/recruit/capture'              => 'リクルートかんたん支払い与信後売上請求サンプル画面',
      'web/recruit/extend_auth'          => 'リクルートかんたん支払い与信期限延長請求サンプル画面',
      'web/linepay/authorize'            => 'LINE Pay与信サンプル画面',
      'web/linepay/cancel'               => 'LINE Pay取消請求サンプル画面',
      'web/linepay/capture'              => 'LINE Pay与信後売上請求サンプル画面',
      'web/masterpass/authorize'         => 'MasterPass与信サンプル画面',
      'web/masterpass/cancel'            => 'MasterPass取消サンプル画面',
      'web/masterpass/capture'           => 'MasterPass与信後売上サンプル画面',
      'web/masterpass/login'             => 'MasterPass申込サンプル画面',
      'web/virtualacc/authorize'         => '銀行振込決済与信サンプル画面',
      'web/virtualacc/cancel'            => '銀行振込決済取消サンプル画面',
      'web/virtualacc/deposit_entry'     => '銀行振込決済入金請求サンプル画面',
      'web/virtualacc/deposit_reverse'   => '銀行振込決済入金取消サンプル画面',
      'web/virtualacc/reconcile'         => '銀行振込決済消込請求サンプル画面',
      'web/virtualacc/undo_reconcile'    => '銀行振込決済消込取消サンプル画面',
      'web/paypay/cancel'                => 'PayPay取消請求サンプル画面',
      'web/paypay/capture'               => 'PayPay与信後売上請求サンプル画面',
      'web/paypay/menu'                  => 'PayPay取引選択サンプル画面',
      'web/paypay/online_authorize'      => 'PayPay申込(オンライン決済)サンプル画面',
      'web/paypay/refund'                => 'PayPay返金請求サンプル画面',
      'web/paypay/result'                => 'PayPay結果表示サンプル画面',
      'web/amazonpay/authorize'          => 'Amazon Pay与信サンプル画面',
      'web/amazonpay/authorize_confirm'  => 'Amazon Pay与信決済情報確認サンプル画面',
      'web/amazonpay/cancel'             => 'Amazon Pay取消請求サンプル画面',
      'web/amazonpay/capture'            => 'Amazon Pay与信後売上請求サンプル画面',
      'web/amazonpay/get_address'        => 'Amazon Pay住所情報取得請求サンプル画面',
      'web/amazonpay/refund'             => 'Amazon Pay返金請求サンプル画面',
      'web/amazonpay/result'             => '決済申込結果'
    }

    ctrlr = params[:controller]
    act = params[:action]

    result = 'VeriTrans 4G '
    title = titles["#{ctrlr}/#{act}"]
    title = titles["#{ctrlr}"] if title.nil?

    result = result + ' - ' + title unless title.nil?
    return result
  end

  #-------------------------------------------------------------------------
  # コピーライト。
  #-------------------------------------------------------------------------
  def copyright
    return 'Copyright &copy; VeriTrans Inc. All rights reserved'
  end

  #-------------------------------------------------------------------------
  # 指定したURLのコンテンツを取得する。
  #-------------------------------------------------------------------------
  def connect(url)
    uri = URI.parse(url)
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    http.verify_mode = OpenSSL::SSL::VERIFY_NONE
    http.open_timeout = 30000
    http.read_timeout = 30000
    res = http.get(uri.path)
    return res.body
  end

  #-------------------------------------------------------------------------
  # TOPメニューへのリンクを取得する。
  #-------------------------------------------------------------------------
  def top_menu_link(link_name = "決済サンプルのトップメニューへ戻る")
    return link_to link_name, root_path + "top"
  end

  #-------------------------------------------------------------------------
  # 管理者メニューへのリンクを取得する。
  #-------------------------------------------------------------------------
  def admin_menu_link(link_name = "管理メニューへ戻る")
    return link_to link_name, root_path + "top/admin_menu"
  end

  #-------------------------------------------------------------------------
  # PayNowIDメニューへのリンクを取得する。
  #-------------------------------------------------------------------------
  def paynowid_menu_link(link_name = "PayNowIDサンプルのトップメニューへ戻る")
    return link_to link_name, root_path + "top/paynowid_menu"
  end

  #-------------------------------------------------------------------------
  # エラーメッセージを表示する。
  #-------------------------------------------------------------------------
  def error_display
    @err_msg ||= ''
    "<font color='#ff0000'><b>#{@err_msg}</b></font><br/><br/>" unless @err_msg.blank?
  end
end
